/************************************************************************/
/*									*/
/*	File:	aodef.h							*/
/*									*/
/*	System definitions for the assembly language peephole		*/
/*	optimizer.  This include file is intended for use with the	*/
/*	"aoX.c"	source files.						*/
/*									*/
/*		Written	by Kirk	Bailey of Logical Systems.		*/
/*									*/
/*		Copyright (c) 1984-1986	Logical	Systems.		*/
/*									*/
/*				04/20/86				*/
/*									*/
/************************************************************************/

/* ANSI	C  strchr()  =	old index() */
#define	index strchr

#ifdef NOARGS
#define __ARGS(x) ()
#else
#define __ARGS(x) x
#endif

/*
 *	Type shortforms.
 */
typedef	int		BOOL;
typedef	FILE		*STREAM;
typedef	char		*STRING;
typedef	unsigned int	UINT;

/*
 *	General	definitions.
 */
#define	TRUE		1
#define	FALSE		0
#define	DEBUG		TRUE		/* TRUE	enables	debug code */
#define	FOREVER		for(;;)
#define	VERSION		"86.2"		/* Current optimizer version */
#define	VOID void			/* Unused return value */

/*
 *	The following definitions allow	portability to "C" environments
 *	with either 2 or 4 byte	pointers and integers.	Note that PTRUINT
 *	should be set to an integral type (preferably unsigned), which is at
 *	least as wide as pointers are (usually unsigned	int or long).
 */

#define	PTR4		TRUE		/* Pointers are	4 bytes	long, not 2 */
#define	UINT4		TRUE		/* UINT's are 4	bytes long, not	2 */
typedef	unsigned	PTRUINT;	/* Integral type as wide as pointer */

/*
 *	I/O definitions.
 */
#define	FNSIZE		80		/* # of	characters in filename */
#define	INPUT_EXT	".cas"		/* Input filename default extension */
#define	MAXLNSIZE	132		/* Longest legal input line */
#define	OUTPUT_EXT	".mac"		/* Output filename default extension */
#define	RESTART_EXT	".rst"		/* Restart filename default ext. */

/*
 *	Data structure definitions.
 */
#define	JQSIZE		8192		/* # of	chars in jump queue */

#define	OPNMESIZE	5		/* Max.	# chars	in opcode */

#define	SYMNMESIZE	15		/* Max.	# chars	in a symbol (was 8 ACZ)	*/
#define	SYMTABSIZE	2048		/* # items in sym. tbl.	(see next) */
#define	SYMTABMASK	0x07FF		/* Log base 2 of "SYMTABSIZE" */
/*
 *	Allowed	values for program "exit"s.
 */
#define	ERRORS		1		/* Erase "$$$.sub"/"$$$.bat" file */
#define	NOERRORS	0		/* Normal termination */

/*
 *	Mnemonic definitions for state information.
 */
#define	NORMTYPE	0		/* Match Q type	for non	jump/label */
#define	LABTYPE		1		/* Match queue type for	labels */
#define	JMPTYPE		2		/* Match queue type for	jumps */
#define	CALLTYPE	3		/* Unconditional call instruction */
#define	EXJPTYPE	4		/* Was a JP, now a JR */

/*
struct symtab *add_jmp __ARGS((void));
struct symtab *add_lab __ARGS((void));
VOID banner __ARGS((void));
VOID	chkfreq __ARGS((void));
VOID	fatal __ARGS((char *, char *));
char	get_jq __ARGS((void));
struct symtab *lookup __ARGS((void));
VOID	makefn __ARGS((char *, char *, char *));
VOID	optimize __ARGS((void));
BOOL	put_jq __ARGS((char));
BOOL	read_jq __ARGS((void));
char	scan_jq __ARGS((void));
VOID	usagerr __ARGS((void));
BOOL	write_jq __ARGS((void));

VOID	do_jopts __ARGS((char *));
UINT	ii __ARGS((void));
BOOL	isreg __ARGS((void));
BOOL	isrp __ARGS((void));
BOOL	isxrp __ARGS((void));
BOOL	match __ARGS((char *));
int	nc1 __ARGS((void));
int nextc __ARGS((void));
UINT	one __ARGS((void));
BOOL	parse __ARGS((void));
UINT	scase1 __ARGS((void));
UINT	scase2 __ARGS((void));
UINT	scase3 __ARGS((void));
UINT	scase4 __ARGS((void));
UINT	scase5 __ARGS((void));
UINT	scase6 __ARGS((void));
UINT	scase7 __ARGS((void));
VOID	size __ARGS((void));
UINT	size1 __ARGS((void));
UINT	size2 __ARGS((void));
UINT	size3 __ARGS((void));
UINT	size4 __ARGS((void));
UINT	size5 __ARGS((void));
UINT	size6 __ARGS((void));
UINT	size7 __ARGS((void));
UINT	size8 __ARGS((void));
UINT	size9 __ARGS((void));
UINT	size10 __ARGS((void));
UINT	size11 __ARGS((void));
UINT	two __ARGS((void));
UINT	zero __ARGS((void));

BOOL	findit __ARGS((char *));
VOID	lnk_rst __ARGS((void));
VOID	r_rst __ARGS((void));
UINT	scase8 __ARGS((void));
UINT	size12 __ARGS((void));
*/
