/************************************************************************/
/*									*/
/*	File:	aotyp.h							*/
/*									*/
/*	Data type declarations for the assembly	language peephole	*/
/*	optimizer.  This is an include file for	the "aoX.c" program	*/
/*	source files.							*/
/*									*/
/*		Written	by Kirk	Bailey of Logical Systems.		*/
/*									*/
/*		Copyright (c) 1984-1986	Logical	Systems.		*/
/*									*/
/*				04/20/86				*/
/*									*/
/************************************************************************/

struct	queue				/* Data	structure defining a queue */
	{
	STRING	strt;			/* Physical start of queue */
	STRING	end;			/* Physical end	of queue */
	STRING	in;			/* Logical start of queue */
	STRING	out;			/* Logical end of queue	*/
	STRING	scan;			/* Internal "scanning" pointer */
	};

struct	opcode				/* Instruction code length entry */
	{
	char	oname[OPNMESIZE	+ 1];	/* Instruction/pseudo-op name */
	UINT	(*length)();		/* Pointer to length function */
	};

struct	pbuf				/* Input statement parsing buffer */
	{
	STRING	mptr;			/* Matching pointer within "sb"	*/
	UINT	rept;			/* Repeat count	with "rept" macro */
	char	sb[MAXLNSIZE + 1];	/* Statement buffer */
	UINT	size;			/* Length of buffer instruction	*/
#if	SYMNMESIZE >= OPNMESIZE
	char	symbuf[SYMNMESIZE + 1];	/* Active symbol/opcode	in buffer */
#else
	char	symbuf[OPNMESIZE + 1];	/* Active symbol/opcode	in buffer */
#endif
	char	type;			/* Type	of buffer instruction */
	};

struct	rstslot				/* Restart vector substitution */
	{
	char	rname[SYMNMESIZE + 1];	/* Replace this	name with restart */
	BOOL	copy;			/* TRUE	if code	to be copied */
	};

struct	symtab				/* Symbol table	*/
	{
	char	sname[SYMNMESIZE];	/* Ascii symbol	name */
	union
		{
		UINT callcnt;		/* # of	calls to symbol	*/
		struct			/* Or */
			{
			char	jmpcnt;	/* # of	"convertable" jumps to it */
			char	islabel;	/* TRUE	if label in MQ */
			} jinfo;
		} info;
	};


