/**************************************************************************\
*									   *
*   REL.C   -	unido X-Mac, Lese- und Schreib-Utilities fuer		   *
*		Microsoft-REL-Format					   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>		/* Standard-I/O	benutzt		  */
#include <string.h>		/* Stringfunktionen benutzt	  */
#include "all.h"		/* allgemeine Festlegungen	  */
#include "rel_old.h"		/* Aufbau REL			  */

/*
int	 getrel(void);
int	 getspec(void);
int	 gettyp(void);
int	 getfld(void);
int	 getsym(void);
int	 getbits(int);
BOOLEAN	 putrel(void);
BOOLEAN	 puttyp(void);
BOOLEAN	 putfld(void);
BOOLEAN	 putsym(void);
BOOLEAN	 putbits(unsigned, int);
*/


/*								Globals	  */
/**************************************************************************/

FILE	   *inrel;	      /* Eingabe-REL-Datei			  */
FILE	   *outrel;	      /* Ausgabe-REL-Datei			  */

unsigned    inrem;	      /* verbleibende Bits im Eingabebyte	  */
unsigned    inchunk;	      /* aktuelles Byte	aus Eingabe-REL-Datei	  */
unsigned    outrem = 8;	      /* verbleibende Bits im Ausgabebyte	  */
unsigned    outchunk;	      /* aktuelles Byte	fuer Ausgabe-REL-Datei	  */
unsigned    item;	      /* aktueller Item-Code			  */
unsigned    type;	      /* Typfeld				  */
unsigned    field;	      /* aktuelles Bitfeld			  */

char	    symbol[17];	      /* aktueller Symbolstring	(0-terminiert)	  */





/**************************************************************************\
*									   *
* action      :	 Naechstes REL-Item aus	Datei inrel holen.		   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 inrel	 -  geoeffnete REL-Lesedatei			   *
*									   *
* r/w globals :	 inrem	 -  Anzahl verbleibende	Bits in	inchunk		   *
*		 inchunk -  aktuell gelesenes Byte aus inrel		   *
*		 item	 -  Item-Code					   *
*		 type	 -  Feld-Typ					   *
*		 field	 -  Feld-Wert					   *
*		 symbol	 -  Symbolname					   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 Item-Code im Erfolgsfall,				   *
*		 ERR sonst.						   *
*									   *
\**************************************************************************/

int getrel(void)
  {
    if (!getbits(1)) return (ERR);	/* 1 Bit holen			  */
    if (field == 0)
      {					/* absolutes Item		  */
	if (!getbits(8)) return	(ERR);	/* naechste 8 Bit holen		  */
	return (type = item = ABS);	/* absolutes Item !		  */
      }
    if (!getbits(2)) return (ERR);	/* 2 weitere Bit holen		  */
    switch (type = item	= field)
      {
	case 0:	return (getspec());	/* spezielles Link-Item		  */
	case 1:				/* programmrelativ		  */
	case 2:				/* datenrelativ			  */
	case 3:	break;			/* commonrelativ		  */
      }
    if (getfld() == ERR) return	(ERR);	/* naechste 16 Bit holen	  */
    return (item);			/* relatives Item		  */
  }





/**************************************************************************\
*									   *
* action      :	 Spezielles Item holen.					   *
*									   *
 **************************************************************************
*									   *
*   ( s.o. getrel() )							   *
*									   *
\**************************************************************************/

int getspec(void)
  {
    if (!getbits(4)) return (ERR);	/* 4 Bit holen			  */
    type = ABS;				/* voreingestellter Typ		  */
    item = field + 4;
    switch (field)
      {
	case  0:			/* Einsprungpunkt		  */
	case  1:			/* Commonblock auswaehlen	  */
	case  2:			/* Programmname			  */
	case  3:			/* Bibliothekssuche erforderlich  */
	case  4:			/* erweitertes Link-Item	  */
	  if (getsym() == ERR)
	    return (ERR);
	break;

	case  5:			/* Common-Groesse definieren	  */
	case  6:			/* Anfang einer	Verweiskette	  */
	case  7:			/* Einsprungspunkt definieren	  */
	  if (	  gettyp() == ERR
	       || getfld() == ERR
	       || getsym() == ERR
	     ) return (ERR);
	break;

	case  8:			/* extern - Offset		  */
	case  9:			/* extern + Offset		  */
	case 10:			/* Groesse des Datenbereichs	  */
	case 11:			/* Positionszaehler Laden setzen  */
	case 12:			/* Verkettungsadresse		  */
	case 13:			/* Programmgroesse		  */
	  if (	  gettyp() == ERR
	       || getfld() == ERR
	     ) return (ERR);
	break;

	case 14:			/* Programmende			  */
	  if (	  gettyp() == ERR
	       || getfld() == ERR
	     ) return (ERR);
	  inrem	= 0;			/* muss	an Bytegrenze		  */
	break;

	case 15:			/* Dateiende			  */
	  inrem	= 0;			/* muss	an Bytegrenze		  */
	break;
      }
    return (item);
  }





/**************************************************************************\
*									   *
* action      :	 Typfeld holen.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 inrel	 -  geoeffnete REL-Lesedatei			   *
*									   *
* r/w globals :	 inrem	 -  Anzahl verbleibende	Bits in	inchunk		   *
*		 inchunk -  aktuell gelesenes Byte aus inrel		   *
*		 type	 -  Feld-Typ					   *
*		 field	 -  Feld-Wert					   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	Typfeld	im Erfolgsfall,					   *
*		ERR sonst						   *
*									   *
\**************************************************************************/

int gettyp(void)
  {
    if (!getbits(2)) return (ERR);	/* Typfeld holen (2 Bit	lang)	  */
    return (type = field);
  }





/**************************************************************************\
*									   *
* action      :	 16-Bit-Feld holen, Itemcode zurueckgeben.		   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 item	-  Itemcode, der zurueckgegeben	wird		   *
*									   *
* r/w globals :	 field	-  16-Bit-Feld,	das gesetzt wird		   *
*									   *
* locals      :	 low	-  Zwischenspeicher Low-Byte fuer field		   *
*									   *
* returns     :	 Itemcode des geholten Feldes oder ERR,	wenn Fehler	   *
*		 auftraten						   *
*									   *
\**************************************************************************/

int getfld(void)
  {
    int	low;

    if (!getbits(8)) return (ERR);	/* die ersten 8	Bit holen	  */
    low	= field;			/* und sichern			  */
    if (!getbits(8)) return (ERR);	/* die naechsten 8 Bit holen	  */
    field = (field << 8) | low;		/* geholte Werte kombinieren	  */
    return (item);
  }





/**************************************************************************\
*									   *
* action      :	 Symbol	holen, Itemcode	zurueckgeben.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 item	-  Itemcode, der zurueckgegeben	wird		   *
*									   *
* r/w globals :	 symbol	-  zu setzendes	Symbol				   *
*									   *
* locals      :	 i	-  Zaehler Symbollaenge				   *
*		 save	-  Sicherung fuer field				   *
*		 cp	-  Zeiger in Symbol				   *
*									   *
* returns     :	 Itemcode des geholten Feldes oder ERR,	wenn Fehler	   *
*		 auftraten						   *
*									   *
\**************************************************************************/

int getsym(void)
  {
    int	    i;
    int	    save;
    char   *cp;

    cp = symbol;			/* Symbolanfang			  */
    save = field;			/* Feld	aufheben		  */
    if (!getbits(3)) return (ERR);	/* Symbollaenge	holen (3 Bit)	  */
    i =	field;				/* Laenge merken		  */
    while (i--)				/* alle	Symbolzeichen holen	  */
      {
	if (!getbits(8)) return	(ERR);	/* naechstes Byte holen		  */
	*cp++ =	field;
      }
    *cp	= '\0';				/* Symbol abschliessen		  */
    field = save;			/* Feld	wiederherstellen	  */
    return (item);			/* Itemcode zurueckgeben	  */
  }





/**************************************************************************\
*									   *
* action      :	 Holen der naechsten n Bits aus	der REL-Datei inrel in	   *
*		 field.							   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 n	  -  Anzahl der	zu holenden Bits (1 < n	<= 16)	   *
*									   *
* r/o globals :	 inrel	  -  REL-Datei,	aus der	die Bits geholt	werden	   *
*									   *
* r/w globals :	 field	  -  Ergebnis, enthaelt	bei Rueckgabe die aus	   *
*			     inrel gelesenen Bits, rechtsbuendig, links	   *
*			     das zuerst	geholte	Bit, nicht benutzte Bits   *
*			     sind 0					   *
*		 inrem	  -  Anzahl noch nicht geholter	Bits in	inchunk	   *
*		 inchunk  -  aus inrel gelesenes Byte, inrem Bits davon	   *
*			     noch nicht	geholt (Start bei Bit 0)	   *
*									   *
* locals      :	 get	  -  Merker wieviele Bits auf einmal geholt	   *
*									   *
* returns     :	 TRUE	  -  Bits ohne Fehler geholt			   *
*		 FALSE	  -  Fehler beim Holen				   *
*									   *
\**************************************************************************/

int getbits(int	n)
  {
    int	get;
    int	temp;

    field = 0;					  /* Ergebnis loeschen	  */
    while (n)					  /* solange Bits zu	  */
      {						  /* zu	holen sind	  */
	if (inrem == 0)				  /* Reste in inchunk ?	  */
	  {					  /* nein, neues Byte	  */
	    if ((temp =	getc(inrel)) ==	EOF)	  /* aus Datei holen	  */
	      {
		puts("\n- Abnormal End of REL File");
		return (FALSE);			  /* Fehlschlag		  */
	      }
	    inchunk = temp;
	    inrem = 8;				  /* 8 Bit in inchunk	  */
	  }
	if (n >	inrem)				  /* wieviele noetig ?	  */
	  get =	inrem;
	else
	  get =	n;
	n -= get;				  /* Bedarfszaehler	  */
	inrem -= get;
	field =	(field << get) +		  /* Ergebnis bauen	  */
		((inchunk >> inrem) & ~(ONES <<	get));
      }	/* end while */
    return (TRUE);
  }





/**************************************************************************\
*									   *
* action      :	 Schreiben eines REL-Eintrages in relokatible		   *
*		 REL-Objektdatei.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 item	    - Item-Code					   *
*		 type	    - Typ des Felds				   *
*		 field	    - Wert des Felds				   *
*		 symbol	    - Name des Symbols				   *
*									   *
* r/w globals :	 outrel	    - Ausgabe-REL-Datei				   *
*		 outrem	    - verbleibende Bits	in outchunk		   *
*		 outchunk   - aktuelles	Byte fuer REL-Datei		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 TRUE im Erfolgsfall, FALSE sonst			   *
*									   *
\**************************************************************************/

BOOLEAN	putrel(void)
  {

    switch (item)			/* einfache Elemente :		  */
      {
	case ABS    :			/*   0 <8 bit>			  */
	  if (	  !putbits(0,1)
	       || !putbits(field,8)
	     ) return (FALSE);
	  return (TRUE);

	case PREL   :			/*   1 01 <16 bit>		  */
	case DREL   :			/*   1 10 <16 bit>		  */
	case CREL   :			/*   1 11 <16 bit>		  */
	  if (	  !putbits(1,1)
	       || !putbits(item,2)
	       || !putfld()
	     ) return (FALSE);
	  return (TRUE);
      }

    if (    !putbits(4,3)		/* Rest	eingeleitet durch 1 00	  */
	 || !putbits(item-4,4)		/* und 4 Bit Elementcode	  */
       ) return	(FALSE);

    switch (item)			/* zusammengesetzte Elemente :	  */
      {
	case CSIZE  :			/*   ... tt <16	bit> lll <string> */
	case XCHAIN :
	case EPOINT :
	  if (	  !putbits(type,2)
	       || !putfld()
	     ) return (FALSE);
	case ENAME  :			/*   ... lll <string>		  */
	case CNAME  :
	case PNAME  :
	case LNAME  :
	case EXT    :
	  if (!putsym())
	    return (FALSE);
	  return (TRUE);

	case XMOFF  :			/*   ... tt <16	bit>		  */
	case XPOFF  :
	case DSIZE  :
	case SETLC  :
	case CHAIN  :
	case PSIZE  :
	  if (	  !putbits(type,2)
	       || !putfld()
	     ) return (FALSE);
	  return (TRUE);

	case EPROG  :			/*   ... tt <16	bit>, Bytegrenze  */
	  if (	  !putbits(type,2)
	       || !putfld()
	     ) return (FALSE);
	case EFILE:			/*   (Dateiende), Bytegrenze	  */
	  if (	  outrem < 8		/*   Bytegrenze	erzwingen	  */
	       && !putbits(0,outrem)
	     ) return (FALSE);
	  return (TRUE);
      }
    return (FALSE);
  }





/**************************************************************************\
*									   *
* action      :	 2 Bit Feldangabe type in Ausgabe-REL-Datei outrel	   *
*		 schreiben.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 type	    - zu schreibende 2 Bit Feldtypangabe	   *
*									   *
* r/w globals :	 outrel	    - Ausgabe-REL-Datei				   *
*		 outrem	    - verbleibende Bits	in outchunk		   *
*		 outchunk   - aktuelles	Byte fuer REL-Datei		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 TRUE im Erfolgsfall, FALSE sonst			   *
*									   *
\**************************************************************************/

BOOLEAN	puttyp(void)
  {
    if (putbits(type,2))		/* 2 Bit schreiben		  */
      return (TRUE);			/* alles ok			  */
    return (FALSE);			/* Schreibfehler		  */
  }





/**************************************************************************\
*									   *
* action      :	 16-bit-Feld field in low Byte / high Byte Reihenfolge	   *
*		 in Ausgabe-REL-Datei outrel schreiben.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 field	    - zu schreibendes 16-Bit-Feld		   *
*									   *
* r/w globals :	 outrel	    - Ausgabe-REL-Datei				   *
*		 outrem	    - verbleibende Bits	in outchunk		   *
*		 outchunk   - aktuelles	Byte fuer REL-Datei		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 TRUE im Erfolgsfall, FALSE sonst			   *
*									   *
\**************************************************************************/

BOOLEAN	putfld(void)
  {
    if (putbits(field,8) && putbits(field>>8,8))  /* low Byte /	high Byte */
      return (TRUE);				  /* alles ok		  */
    return (FALSE);				  /* Schreibfehler	  */
  }





/**************************************************************************\
*									   *
* action      :	 Symbol	symbol auf Ausgabe-REL-Datei outrel ausgeben.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 symbol	    - 0-terminierter String des	zu schreibenden	   *
*			      Symbols					   *
*									   *
* r/w globals :	 outrel	    - Ausgabe-REL-Datei				   *
*		 outrem	    - verbleibende Bits	in outchunk		   *
*		 outchunk   - aktuelles	Byte fuer REL-Datei		   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 TRUE im Erfolgsfall, FALSE sonst			   *
*									   *
\**************************************************************************/

BOOLEAN	putsym(void)
  {
    int	    i;				     /*	Stringlaenge, Index	  */
    char   *cp;				     /*	Zeiger in den String	  */

    if ((i = strlen(symbol)) > MAXSYM)	     /*	hoechste Symbollaenge	  */
      i	= MAXSYM;			     /*	zum Schreiben einhalten	  */
    if (!putbits(i,3)) return (FALSE);	      /* 3 Bit Symbollaenge	   */
    cp = symbol;			     /*	Zeiger aus Symbolstring	  */
    while (i--)				     /*	Symbol ausgeben	:	  */
      if (!putbits(*cp++,8)) return (FALSE);  /*   naechstes Byte ausgeben */
    return (TRUE);			     /*	alles ok		  */
  }





/**************************************************************************\
*									   *
* action      :	 Die naechsten n Bits aus fld in REL-Datei outrel	   *
*		 schreiben.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 fld	    - zu schreibende Bits (rechtsbuendig, zuerst   *
*			      wird das "linkste" Bit geschrieben)	   *
*		 n	    - Anzahl zu	schreibender Bits aus fld	   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 outrel	    - Ausgabe-REL-Datei				   *
*		 outrem	    - verbleibende Bits	in outchunk		   *
*		 outchunk   - aktuelles	Byte fuer REL-Datei		   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 TRUE im Erfolgsfall, FALSE sonst			   *
*									   *
\**************************************************************************/

BOOLEAN	putbits(fld,n)

unsigned   fld;
int	   n;

  {
    int	put;		      /* Anzahl	Bits in	einem Schreibvorgang	  */

    while (n)				/* solange Bits	zu schreiben	  */
      {
	if (n >	outrem)			/* Anzahl Bits fuer naechsten	  */
	  put =	outrem;			/* Schreibvorgang = Minimum (	  */
	else				/* freie Bits Ausgabebyte,	  */
	  put =	n;			/* noch	zu schreibende Bits )	  */

	/* Ausgabebyte setzen */
	outchunk = (outchunk <<	put) + ((fld >>	(n-put)) & ~(ONES << put));

	n -= put;			/* so viele Bits muessen wir noch */
	outrem -= put;			/*  "	 noch frei im Ausgabebyte */
	if (outrem == 0)		/* Ausgabebyte voll, schreiben	  */
	  {
	    putc(outchunk,outrel);	/* Byte	schreiben		  */
	    if (ferror(outrel))		/* Fehler dabei	?		  */
	      {
		puts("\n- Write	Error in REL File");   /* ja ...	  */
		return (FALSE);
	      }
	    outrem = 8;			/* neues Ausgabebyte = 8 Bit frei */
	  }
      }	/* end while */
    return (TRUE);			/* alles ok			  */
  }



/* Ende	von REL.C */
