/**************************************************************************\
*									   *
*   DREL.C   -	 unido X-Mac, Dump einer REL- oder LIB-Datei im		   *
*		 Microsoft-REL-Format					   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/



/*
 *   Aufruf :
 *
 *   DREL <Dateispezifikation>
 *
 *   Die Ausgabe geht auf stdout und kann daher	umgelenkt werden.
 *   Der Dateiname kann	mit der	Extension angegeben werden,
 *   Default-Extension ist REL.
 *
 */





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include "all.h"			/* allgemeine Festlegungen	  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"
#include "ctp.h"
#include "rele.h"			/* Externals REL.C		  */





/*	      externe nicht-int-Funktionen (nicht aus stdio.h/string.h)	  */
/**************************************************************************/

extern char *itou();
extern char *itox();
/* extern FILE *fopenb(); no longer used */





/*								Globals	  */
/**************************************************************************/

char	   infn[FNSIZE + 1];	   /* Path/Dateiname zu	dumpende Datei	  */
unsigned   lc;			   /* Ausgabezahl			  */
unsigned   seg;			   /* Segmenttyp (PREL/DREL), Modulstart  */
				   /* PREL, sonst durch	SETLC gesetzt	  */
unsigned   width;		   /* aktuelle Anzahl Objekte/Zeile	  */

VOID seerel __ARGS((void));
VOID see8 __ARGS((int, int));
VOID see16 __ARGS((void));
VOID seenam __ARGS((char *, int));
char xtype __ARGS((void));
VOID newlin __ARGS((int));
VOID outsz __ARGS((char	*));
VOID outsz __ARGS((char	*));




/**************************************************************************\
*									   *
* action      :	 Hauptprogramm.	Lesen und Dumpen einer beim Aufruf	   *
*		 angegebenen Datei unter Beachtung des REL-Formats.	   *
*		 Alle Ausgaben gehen auf stdout, alle Fehlermeldungen	   *
*		 auch.							   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 argc, argv  - Aufrufparameter				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 infn -	Dateiname der Eingabedatei			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 Errorcode 1 bei Fehlern				   *
*		 Errorcode 0 sonst					   *
*									   *
\**************************************************************************/

void main(argc,argv)

int argc;					  /* Aufrufparameter	  */
char *argv[];					  /* werden benutzt	  */

  {
    int	ppos;					  /* Index '.' Dateiname  */


    puts("unido	REL/LIB-Dump Version 1.0");
    puts("ported to Linux by dl4sdc");

    if (argc !=	2)				  /* Dateiangabe noetig	  */
      fatal("Usage is 'drel <infile>'","");

    strcpy(infn,*++argv);			  /* Dateinamen	aufbauen  */
    ppos = strlen(infn)	- 1;
    while (    ppos > 0
	    && infn[ppos] != '\\'
	    && infn[ppos] != '/'
	    && infn[ppos] != '.' ) --ppos;
    if (infn[ppos] != '.') strcat(infn,".REL");

    if (!(inrel	= fopen(infn,"rb")))		  /* Inputdatei	oeffnen	  */
      fatal("Unable to open input file:	",infn);  /* Abbruch bei Fehler	  */
    do
      {						  /* naechsten REL-	  */
	if (getrel() ==	ERR)			  /* Eintrag holen	  */
	  fatal("Read unknown REL format","");	  /* (Abbruch bei Fehler) */
	seerel();				  /* und anzeigen	  */
      }
    while (item	!= EFILE);			  /* solange nicht Ende	  */
    puts("\n");
    fclose(inrel);				  /* Eingabe schliessen	  */
  }





/**************************************************************************\
*									   *
* action      :	 REL-Item formatiert an	stdout ausgeben.		   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 item	-  Item-Code					   *
*		 type	-  Typ des Felds				   *
*		 field	-  Wert	des Felds				   *
*		 symbol	-  Name	des Symbols				   *
*									   *
* r/w globals :	 lc	-  aktueller Locationcounter			   *
*		 seg	-  Typ lc					   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID seerel()
  {
    char str[6];	      /* String	fuer Zahlenausgabe		  */
    int	tmp;		      /* Typzwischenspeicher			  */

    switch (item)
      {
	case	ABS:  see8(field,' ');		       /* 1 abs. Byte	  */
		      lc += 1;
		      newlin(NO);		       /* mehrere/Zeile	  */
		      return;
	case   PREL:
	case   DREL:
	case   CREL:  see16();			       /* 1 Wort	  */
		      lc += 2;
		      newlin(NO);		       /* mehrere/Zeile	  */
		      return;
	case  XMOFF:				       /* Offset	  */
	case  XPOFF:  tmp = type;		       /* type sichern	  */
		      type = item;		       /* fuer Ausgabe	  */
		      see16();			       /* Offset ausgeben */
		      type = tmp;		       /* type restaur.	  */
		      newlin(NO);		       /* mehrere/Zeile	  */
		      return;

	case  ENAME:  seenam("	   entry: ",NO);       /* Entrysymbol	  */
		      goto eol;			       /* eins/Zeile	  */
	case  CNAME:  seenam("	  common: ",NO);       /* Commonsymbol	  */
		      goto eol;			       /* eins/Zeile	  */
	case  PNAME:  putchar('\n');		       /* Modulanfang	  */
		      seenam("-	 program: ",NO);       /* Modulname	  */
		      lc = 0;			       /* Neuanfang	  */
		      seg = PREL;		       /* def. Startseg.  */
		      goto eol;			       /* einer/Zeile	  */
	case  LNAME:  seenam("	 library: ",NO);       /* Libraryname	  */
		      goto eol;			       /* einer/Zeile	  */
	case	EXT:  newlin(YES);
		      puts("extension link item");     /* speziell */
		      return;

	case  CSIZE:  seenam(" common sz: ",YES);      /* Commonblock	  */
		      goto eol;			       /* einer/Zeile	  */
	case XCHAIN:  seenam(" ext chain: ",YES);      /* Kettenanfang	  */
		      goto eol;			       /* einer/Zeile	  */
	case EPOINT:  seenam("	entry pt: ",YES);      /* Einsprung	  */
		      goto eol;			       /* einer/Zeile	  */

	case  DSIZE:  newlin(YES);		       /* Datengroesse	  */
		      fputs(" data size: ",stdout);    /* in neuer Zeile  */
		      goto fld;
	case  SETLC:  newlin(YES);		       /* Ladeadresse	  */
		      fputs("	load at: ",stdout);    /* in neuer Zeile  */
		      lc = field;
		      seg = type;		       /* Ladetyp	  */
		      goto fld;
	case  CHAIN:  newlin(YES);		       /* Kettenanfang	  */
		      fputs(" ld chn at: ",stdout);    /* in neuer Zeile  */
		      goto fld;
	case  PSIZE:  newlin(YES);		       /* Programmgroesse */
		      fputs(" prog size: ",stdout);    /* in neuer Zeile  */
		      goto fld;

	case  EPROG:  newlin(YES);		       /* Modulende	  */
		      fputs("- end prog: ",stdout);    /* + Startadresse  */
		      goto fld;			       /* in neuer Zeile  */
	case  EFILE:  newlin(YES);		       /* Dateiende	  */
		      fputs("- end file",stdout);      /* in neuer Zeile  */
		      goto eol;

		      fld: see16();		       /* ein Feld/Zeile  */
		      eol: newlin(YES);		       /* neue Zeile	  */
			   return;		       /* beginnen	  */
      }
    itou(item,str,6);				       /* unbekannt	  */
    fputs(str,stdout);
    puts(" is an Unknown Item Code");
  }





/**************************************************************************\
*									   *
* action      :	 8 Bit Wert value ausgeben an stdout, ggf. mit Suffix	   *
*		 suff. Bei Anfang einer	neuen Zeile und	Codeausgabe den	   *
*		 Locationcounter formatiert mit	Typ ausgeben.		   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 value	-  auszugebender Wert				   *
*		 suff	-  wenn	ungleich 0, dann hinter	dem Wert	   *
*			   auszugebendes Suffixzeichen			   *
*									   *
* r/o globals :	 type	-  Typ des auszugebenden Wertes			   *
*		 item	-  Item	des Wertes				   *
*		 lc	-  aktueller Locationcounter			   *
*		 seg	-  Type	des lc					   *
*									   *
* r/w globals :	 width	-  Anzahl Objekte in Zeile, wenn 0 wird	eine neue  *
*			   Zeile mit Ausgabe Locationcounter begonnen	   *
*			   falls normale Codeausgabe			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID see8(value,suff)

int value;
int suff;

  {
    char str[5];			/* String fuer Zahlenausgabe	  */
    int	save;				/* Sicherung fuer type		  */

    if (width == 0 && item <= XPOFF)	/* falls Codeausgabe + neue Zeile */
      {
	fputs("		   ",stdout);	/*   Justierblanks		  */
	itox(lc,str,5);			/*   Locationcounter mit	  */
	outsz(str);			/*   fuehrenden	Nullen ausgeben	  */
	save = type;			/*   type sichern		  */
	type = seg;			/*   Typ lc holen und		  */
	putchar(xtype());		/*   ausgeben			  */
	type = save;			/*   type restaurieren		  */
	fputs("	 ",stdout);		/*   Format ...			  */
      }
    itox(value & 0xFF,str,3);		/* Wert	in Hex-String umwandeln	  */
    outsz(str);				/* mit fuehrenden Nullen ausgeben */
    if (suff) putchar(suff);		/* ggf.	Suffix ausgeben		  */
    ++width;				/* Zeilenlaenge	hochzaehlen	  */
  }





/**************************************************************************\
*									   *
* action      :	 16 Bit-Feld mit Typangabe ausgeben, wenn am Zeilenanfang  *
*		 Justierblanks und Locationcounter ausgeben, siehe see8(). *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 field	-  auszugebener	16-Bit-Wert			   *
*		 (type	-  Type	des Wertes, wird in xtype() benutzt)	   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID see16()
  {
    see8(field >> 8,0);			/* High-Byte ausgeben		  */
    see8(field,xtype());		/* Low-Byte und	Typ ausgeben	  */
    putchar(' ');
  }





/**************************************************************************\
*									   *
* action      :	 Symbolname mit	Vorlaufstring und ggf. Wert und	Typ an	   *
*		 stdout	ausgeben.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 pref	-  Zeiger auf String, der vor der Symbolausgabe	   *
*			   ausgegeben werden soll			   *
*		 val	-  TRUE: field/type werden als Wert vor	dem Symbol *
*				 ausgegeben, FALSE sonst		   *
*									   *
* r/o globals :	 symbol	-  Zeiger auf String des auszugebenden Symbols	   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID seenam(pref,val)

char   *pref;
int	val;

  {
    newlin(YES);			/* Symbole immer in eigener Zeile */
    width = 1;				/* 1 Symbol in Zeile		  */
    fputs(pref,stdout);			/* String vor dem Symbol ausgeben */
    if (val)				/* Wert	auch auszugeben	?	  */
      {
	see16();			/*   ja	- erst Wert/Typ	ausgeben  */
	putchar(' ');
      }
    fputs(symbol,stdout);		/* Symbol ausgeben		  */
  }





/**************************************************************************\
*									   *
* action      :	 In Abhaengigkeit von type ein Zeichen zurueckgeben, das   *
*		 den Typ charakterisiert (s.u.).			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 type	-  zu kennzeichnender Typ			   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 das type entsprechende	Zeichen, s.u.			   *
*									   *
\**************************************************************************/

char xtype()
  {
    switch (type)
      {
	case   ABS:  return (' ');		  /* bekannter Typ	  */
	case  PREL:  return ('\'');
	case  DREL:  return ('\"');
	case  CREL:  return ('~');
	case XPOFF:  return ('+');
	case XMOFF:  return ('-');
      }
    return ('?');				  /* unbekannter Typ	  */
  }





/**************************************************************************\
*									   *
* action      :	 Zeilenvorschub	an stdout ausfuehren, falls erforderlich,  *
*		 d.h. wenn die Anzahl der Objekte in der Ausgabezeile 15   *
*		 ueberschritten	hat oder durch nl ein Vorschub erzwungen   *
*		 wird und kein Zeilenvorschub gerade vorher stattfand.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 nl	-  TRUE: Zeilenvorschub	erzwingen, FALSE sonst	   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 width	-  aktuelle Anzahl Objekte in Ausgabezeile, 0 nach *
*			   Zeilenvorschub				   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID newlin(nl)

int nl;

  {
    if (width >	15 || (nl && width))	/* Zeilenvorschub erforderlich ?  */
      {
	putchar('\n');			/* ja, an stdout ausfuehren	  */
	width =	0;			/*     jetzt in	leerer Zeile	  */
      }
  }





/**************************************************************************\
*									   *
* action      :	 Im String str fuehrende Blanks	durch Nullen ersetzen und  *
*		 dann den String ausgeben an stdout.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 str	-  Zeiger auf auszugebenden String		   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 cp	-  Zeiger in String				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID outsz(str)

char *str;
  {
    char *cp;

    cp = str;				/* Stringanfang			  */
    while (*cp == ' ') *cp++ = '0';	/* fuehrende Blanks -> Nullen	  */
    fputs(str,stdout);			/* String ausgeben		  */
  }



/* Ende	von DREL.C */
