/**************************************************************************\
*									   *
*   LNK.H   -	unido X-Mac, Headerdatei Linker				   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*								Defines	  */
/**************************************************************************/

#define	COMBASE	    0x100     /* CP/M Programmstart TPA			  */

			      /* Bits Referenztabelle (cr ..., Typfeld)	: */
#define	XRPBIT	    0x80      /*   Plusoffset auf externe Referenz	  */
#define	SEGBITS	    0x0C      /*   die Segmentbits :			  */
#define	CSEGBIT	    0x04      /*   Codesegment				  */
#define	DSEGBIT	    0x08      /*   Datensegment				  */
#define	RELBITS	    0x03      /*   PREL/DREL				  */

			      /* Dateiextensions :			  */
#define	MODEXT	    ".rel"    /*   Microsoft REL-Modul			  */
#define	LIBEXT	    ".lib"    /*   Microsoft REL-Library		  */
#define	COMEXT	    ".com"    /*   CP/M	lauffaehiges Programm		  */
#define	BINEXT	    ".bin"    /*   wie .COM, aber andere Startadresse	  */
#define	DATEXT	    ".dat"    /*   falls extra Datensegment		  */
#define	LNKEXT	    ".lnk"    /*   Extension Linkkommandofile		  */

			      /* Symboltabelle :			  */
#define	NXT    0	      /*   Offset Index	auf naechsten Eintrag	  */
#define	VAL    (NXT+INTSZ)    /*   Offset Wert				  */
#define	SYM    (VAL+INTSZ)    /*   Offset Symbol			  */
#define	TYP    (SYM+MAXSYM+1) /*   Offset Typ (PREL/DREL/ABS)		  */
#define	SSZ    (TYP+1)	      /*   Groesse eines Tabelleneintrags	  */
#define	HIGH   127	      /*   groesster zulaessiger Wert +	1 (SYM)	  */

#define	ARGBSZ 4000	      /* Puffergroesse LNK-File			  */
#define	ARGMAX 32	      /* maximale Anzahl Argumente bei Aufruf	  */
			      /* plus denen aus	LNK-File		  */
#define	STBSZ  60000	      /* Puffergroesse Index/Symboltabelle	  */
			      /*   Achtung: muss < 64k sein !		  */
#define	CDBSZ  0xFFF0	      /* Code/Datensegmentbuffergroesse		  */
			      /*   Achtung: muss < 64k sein !		  */

void	strupper __ARGS((char *));
int	getarg __ARGS((int, char *, int, int, char **));
BOOLEAN	extend __ARGS((char *, char *, char *));
void	newfn __ARGS((char *, char *, char *));
void	search __ARGS((void));
BOOLEAN	getname __ARGS((void));
void	usage __ARGS((void));
BOOLEAN	isunres __ARGS((void));
VOID	load __ARGS((void));
VOID	link __ARGS((void));
void	putwcr __ARGS((unsigned, unsigned));
VOID	phase1 __ARGS((int, char **));
void	phase2 __ARGS((void));
void	resolve __ARGS((void));
void	newsym __ARGS((char **));
BOOLEAN	okay __ARGS((void));

/* Ende	von LNK.H */
