/**************************************************************************\
*									   *
*   LNK2.C   -	  unido	X-Mac, Linker, Teil 2 von 3			   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include "all.h"			/* allgemeine Festlegungen	  */
#include "lnk.h"			/* Definitionen	fuer Linker	  */
#include "lnke.h"			/* Externals LNK.C		  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"
#include "rele.h"			/* Externals REL.C		  */





/**************************************************************************\
*									   *
* action      :	 Feststellen, ob es sich bei dem Symbol	symbol um eine	   *
*		 nicht aufgeloeste externe Referenz handelt.		   *
*									   *
*		 Falls ja, zeigt xrnext	auf entsprechenden Eintrag in	   *
*		 Symboltabelle.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 symbol	  -  String zu untersuchendes Symbol		   *
*		 xrfirst  -  Zeiger auf	ersten Eintrag in Externalliste	   *
*			     (alphabetische Liste !)			   *
*		 crstart  -  Zeiger auf	Basis der Symboltabelle		   *
*									   *
* r/w globals :	 xrnext	  -  zeigt, falls symbol gefunden, auf den	   *
*			     passenden Eintrag in der Externalliste	   *
*									   *
* locals      :	 i	  -  Ergebnisbuffer strcmp()			   *
*									   *
* returns     :	 YES  -	 wenn symbol externes unaufgeloestes Symbol ist	   *
*		 NO   -	 sonst						   *
*									   *
\**************************************************************************/

BOOLEAN	isunres()
  {
    int	i;

    xrnext = crstart + (long)getuint(xrfirst);	/* 1. echter Eintrag Ext.-Liste	*/
    while (getuint(xrnext))		  /* bis zum Listenende		  */
      {
	if (   (i = strcmp(symbol,xrnext + SYM))  /* Symbole vergleichen, */
	     < 0				  /* nicht gefunden, wenn */
	   ) return (NO);			  /* "kleiner"		  */
	if (i == 0) return (YES);		  /* gefunden !		  */
	xrnext = crstart + (long)getuint(xrnext);	/* weiter in Kette	*/
      }
    return (NO);				  /* nicht gefunden	  */
  }





/**************************************************************************\
*									   *
* action      :	 Externe Referenzen mit	Einsprungstellen verknuepfen.	   *
*									   *
*		 Guckt alle unaufgeloesten Referenzen durch und	vergleicht *
*		 sie mit bekannten Einsprungpunkten. Bei einer		   *
*		 Uebereinstimmung wird die External-Kette mit resolve()	   *
*		 aufgeloest und	der Eintrag der	unaufgeloesten externen	   *
*		 Referenz wird aus der Liste in	die Freiliste umgehaengt.  *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 crstart - Zeiger auf Basis der	Symboltabelle		   *
*		 xrfirst - Zeiger auf Listenanfang unaufgeloeste Externals *
*		 epfirst - Zeiger auf Listenanfang Einsprungpunkte	   *
*									   *
* r/w globals :	 xrnext	 - Zeiger auf aktuelles	unaufgeloeste External	   *
*		 epnext	 - Zeiger auf aktuellen	Einsprungpunkt		   *
*		 sfree	 - Zeiger a. Liste wieder freier Tabelleneintraege *
*									   *
* locals      :	 xrprev	 - Zeiger auf Eintrag vorige externe Referenz	   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID link()
  {
    char *xrprev;

    xrnext = crstart + (long)getuint(xrprev = xrfirst);	     /*	1. External	*/
    epnext = crstart + (long)getuint(epfirst);		     /*	1. Entrypoint	*/
    LOOP
      {
	if (strcmp(xrnext + SYM,epnext + SYM) >	0)
	  {					       /* Ext >	Entry,	  */
	    epnext = crstart + (long)getuint(epnext);	     /*	zum naechsten	*/
	    continue;				       /* Entrypoint	  */
	  }
	if (strcmp(xrnext + SYM,epnext + SYM) <	0)
	  {					       /* Ext <	Entry,	  */
	    xrnext = crstart + (long)getuint(xrprev=xrnext); /*	zum naechsten	*/
	    continue;				       /* External	  */
	  }
	if (*(xrnext + SYM) != HIGH)		  /* Ext == Entry,	  */
	  {					  /* gefunden !		  */
	    resolve();				  /* ext. Ref. aufloesen  */
	    putuint(xrprev,getuint(xrnext));	  /* aus Ext-Kette raus	  */
	    putuint(xrnext,sfree);		  /* in	Freikette	  */
	    sfree = xrnext - crstart;		  /* einhaengen		  */
	    xrnext = crstart + (long)getuint(xrprev);	/* naechste ext. Ref.	*/
	    continue;
	  }
	break;
      }	/* end LOOP */
  }





/**************************************************************************\
*									   *
* action      :	 Modul laden.						   *
*									   *
*		 Ein komplettes	Modul im REL-Format wird von der REL-	   *
*		 Inputdatei geladen. Es	werden die Liste der		   *
*		 unaufgeloesten	Externals, die Liste der Einsprungpunkte,  *
*		 der Codebuffer, der Datenbuffer, der Buffer fuer relative *
*		 Werte geupdatet.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 xrfirst - Zeiger auf Listenanfang unaufgeloeste Externals *
*		 epfirst - Zeiger auf Listenanfang Einsprungpunkte	   *
*		 cbuffer - Basiszeiger fuer Codebuffer			   *
*		 dbase	 - absolute Basisadresse Daten			   *
*		 cbase	 - absolute Basisadresse Code			   *
*		 modname - Modulname fuer Ausgabe			   *
*									   *
* r/w globals :	 (siehe	getrel(), putwcr())				   *
*		 cmod	 - auf 0000 relative Modulstartadresse Code	   *
*		 dmod	 - auf 0000 relative Modulstartadresse Daten	   *
*		 cloc	 - auf 0000 relativer Programmzaehler Code	   *
*		 dloc	 - auf 0000 relativer Programmzaehler Daten	   *
*		 loading - CSEGBIT oder	DSEGBIT, je nachdem in welches	   *
*			   Segment gerade geladen wird			   *
*		 cbnext	 - Zeiger auf naechstes	Byte im	Codebuffer	   *
*		 dbnext	 - Zeiger auf naechstes	Byte im	Datenbuffer	   *
*		 start	 - wird	gesetzt, falls mit EPROG im Modul	   *
*									   *
* locals      :	 offset	 - TRUE: letztes Item war XPOFF			   *
*		 epprev	 - Zeiger auf Eintrag voriger Einsprungpunkt	   *
*		 xrprev	 - Zeiger auf Eintrag vorige externe Referenz	   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID load()
  {
    BOOLEAN    offset;
    char      *epprev;
    char      *xrprev;

    epprev = epfirst;	 /* am Anfang der Listen beginnen fuer das	  */
    xrprev = xrfirst;	 /* Neueinfuegen von Symbolen in alp. Reihenfolge */
    loading = CSEGBIT;	 /* Default Startsegment ist Codesegment	  */
    offset = NO;	 /* letztes Item war nicht XPOFF		  */
    do			 /* ganzes Modul laden (nicht gleich ganze Datei) */
      {
	switch(getrel()) /* REL-Item holen und auswerten		  */
	  {

	    case  DSIZE	:  dmod	= dloc;
			   if (monitor)
			     printf("%5d bytes at %04x\" %04x %s\n",
				    field,dloc,dloc + dbase,modname);
			   if (dbnext -	(long)field < cbnext)
			     fatal("DSIZE Data memory overflow","");
			   break;

	    case    ERR	:  fatal("Corrupt module","");

	    case  EPROG	:  if (type == PREL)
			     {
			       start = cmod + field;
			       if (monitor)
				 {
				   printf("	 start at %04x'	%04x %s",
					  start,start +	cbase,modname);
				   if (!start || bin ||	data)
				     printf(" ignored !");
				   puts("");
				 }
			     }

	    case  ENAME	:  break;

	    case XCHAIN	:  newsym(&xrprev);  break;

	    case EPOINT	:  newsym(&epprev);  break;

	    case  PSIZE	:  cmod	= cloc;
			   if (monitor)
			     printf("%5d bytes at %04x'	%04x %s\n",
				    field,cloc,cloc + cbase,modname);
			   if (cbnext +	(long)field > dbnext)
			     fatal("PSIZE Code memory overflow","");
			   break;

	    case  SETLC	:  if (type == PREL)
			     {
			       loading = CSEGBIT;
			       field +=	cmod;
			       if (cbnext + (long)(field - cloc) > dbnext)
				 fatal("SETLC Code memory overflow","");
			       while (cloc < field)
				 {
				   *cbnext++ = 0;
				   ++cloc;
				 }
			     }
			   else
			     {
			       loading = DSEGBIT;
			       field +=	dmod;
			       if (dbnext - (long)(field - dloc) < cbnext)
				 fatal("SETLC Data memory overflow","");
			       while (dloc < field)
				 {
				   *dbnext-- = 0;
				   ++dloc;
				 }
			     }
			   break;

	    case  XPOFF	:  putwcr(XRPBIT,field);
			   offset = YES;
			   break;

	    case   DREL	:  if (loading == CSEGBIT)
			     {
			       if (cbnext + 2 >	dbnext)
				 fatal("DREL Code memory overflow","");
			       field = field + dmod;
			       putuint(cbnext,CDBSZ - 1	- field);
			       cbnext += 2;
			       putwcr(loading |	DREL,cloc);
			       offset =	NO;
			       cloc += 2;
			     }
			   else
			     {
			       if (dbnext - 2 <	cbnext)
				 fatal("DREL Data memory overflow","");
			       field = field + dmod;
			       putuint(dbnext -	1,CDBSZ	- 1 - field);
			       dbnext -= 2;
			       putwcr(loading |	DREL,dloc);
			       offset =	NO;
			       dloc += 2;
			     }
			   break;

	    case   PREL	:  if (loading == CSEGBIT)
			     {
			       if (cbnext + 2 >	dbnext)
				 fatal("PREL Code memory overflow","");
			       field = field + cmod;
			       putuint(cbnext,field);
			       cbnext += 2;
			       putwcr(loading |	PREL,cloc);
			       offset =	NO;
			       cloc += 2;
			     }
			   else
			     {
			       if (dbnext - 2 <	cbnext)
				 fatal("PREL Data memory overflow","");
			       field = field + cmod;
			       putuint(dbnext -	1,field);
			       dbnext -= 2;
			       putwcr(loading |	PREL,dloc);
			       offset =	NO;
			       dloc += 2;
			     }
			   break;

	    case    ABS	:  if (loading == CSEGBIT)
			     {
			       if (cbnext + 1 >	dbnext)
				 fatal("ABS Code memory	overflow","");
			       *cbnext++ = field;
			       if (offset)
				 {
				   putwcr(loading | ABS,cloc);
				   offset = NO;
				 }
			       ++cloc;
			     }
			   else
			     {
			       if (dbnext - 1 <	cbnext)
				 fatal("ABS Data memory	overflow","");
			       *dbnext-- = field;
			       if (offset)
				 {
				   putwcr(loading | ABS,dloc);
				   offset = NO;
				 }
			       ++dloc;
			     }
			   break;

		default	:  fatal("Unsupported link item","");

	  } /* end switch */
      }	while (item != EPROG);
  }





/**************************************************************************\
*									   *
* action      :	 Ueberpruefen, ob alle Referenzen aufgeloest sind und ob   *
*		 es doppelte Namen gibt	bei den	Einsprungpunkten.	   *
*		 Unaufgeloeste Referenzen und doppelte Einsprungpunkte	   *
*		 ausgeben, Ergebnis zurueckgeben.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 crstart  -  Zeiger auf	Basis der Symboltabelle		   *
*		 xrfirst  -  Zeiger auf	Listenanfang unaufgel. Externals   *
*		 epfirst  -  Zeiger auf	Listenanfang Einsprungpunkte	   *
*									   *
* r/w globals :	 xrnext	  -  (benutzt)					   *
*		 epnext	  -  (benutzt)					   *
*									   *
* locals      :	 err	  -  YES: unaufgeloeste	Referenz oder doppelten	   *
*				  Einsprungpunkt gefunden		   *
*		 eplast	  -  Zeiger auf	Eintrag	letzter	getesteter	   *
*			     Einsprungpunkt				   *
*									   *
* returns     :	 NO	  -  unaufgeloeste Referenz oder doppelten Namen   *
*			     gefunden					   *
*		 YES	  -  alles okay					   *
*									   *
\**************************************************************************/

BOOLEAN	okay()
  {
    BOOLEAN    err;
    char      *eplast;

    err	= (BOOLEAN)(eplast = NULL);	     /*	Initialisierung		  */
    xrnext = crstart + (long)getuint(xrfirst);	   /* erste externe Referenz	*/
    epnext = crstart + (long)getuint(epfirst);	   /* erster Einsprungpunkt	*/
    LOOP				     /*	fuer alle Referenzen	  */
      {
	if (strcmp(xrnext + SYM,epnext + SYM) >	0)     /* xname	> ename	? */
	  {
	    if (epnext == eplast)		       /* ename	doppelt	? */
	      {
		printf("redundant: %s\n",xrnext	+ SYM);
		err = YES;
	      }
	    eplast = epnext;			       /* letzter ep	  */
	    epnext = crstart + (long)getuint(epnext);	     /*	naechster ep	*/
	    continue;
	  }
	if (strcmp(xrnext + SYM,epnext + SYM) <	0)     /* xname	< ename	? */
	  {
	    printf("unresolved:	%s\n",xrnext + SYM);   /* ja, unaufge-	  */
	    err	= YES;				       /* loeste Ref.	  */
	    xrnext = crstart + (long)getuint(xrnext);	     /*	naechste xr	*/
	    continue;
	  }
	if (*(xrnext + SYM) != HIGH)		       /* Listenende ?	  */
	  {					       /* nein,		  */
	    xrnext = crstart + (long)getuint(xrnext);	     /*	naechste xr	*/
	    continue;
	  }
	break;
      }	/* end LOOP */
    if (err) return (NO);
    return (YES);
  }





/**************************************************************************\
*									   *
* action      :	 Eingabedateien	und Bibliotheksmodule laden und	linken	   *
*		 entsprechend der in argc/argv angegebenen Liste.	   *
*									   *
*		 Sind keine Dateinamen ausserhalb der Schalter angegeben,  *
*		 dann Abbruch mit Fehlermeldung. Wenn Ausgabedateiname	   *
*		 outfn noch nicht gesetzt ist, dann Namen der ersten Datei *
*		 nehmen	und je nach bin	mit BINEXT- oder COMEXT-Extension  *
*		 versehen. Dateien mit Library-Extension werden	als	   *
*		 Library (nur unaufgeloeste Referenzen daraus laden)	   *
*		 geladen.						   *
*									   *
*		 Bei monitor ==	YES Ausgabe aller Aktivitaeten,	sonst nur  *
*		 Ausgabe der gesamten Codelaenge und Datenlaenge.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 argc/argv - Kommandozeilenparameter			   *
*									   *
* r/o globals :	 bin	-  YES:	keine COM-Datei				   *
*									   *
* r/w globals :	 infn	-  Dateiname zu	ladende	Datei			   *
*		 inrel	-  Filestrukturzeiger zu infn			   *
*		 outfn	-  s.o.						   *
*									   *
*		 cloc, dloc, crnext, diverse Buffer			   *
*		   werden waehrend des Ladens aktualisiert		   *
*									   *
*		 csize	= cloc	     nach dem Laden			   *
*		 dsize	= dloc						   *
*		 crend	= crnext					   *
*		 crnext	= crstart					   *
*									   *
* locals      :	 i	-  Zaehler Kommandozeilenparameter		   *
*		 lib	-  YES:	zu ladende Datei ist Library		   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID phase1(argc,argv)

int	argc;
char   *argv[];

  {
    int	       i;
    BOOLEAN    lib;

    if (monitor) puts("");			       /* neue Zeile	  */
    i =	0;					       /* alle Argumente  */
    while (getarg(++i,infn,FNSIZE+3,argc,argv) != EOF) /* durchgehen	  */
      {
	/* strupper(infn);			     alles Uppercase	  */
	if (infn[0] == '-') continue;		  /* Schalter ueberlesen  */
	if (extend(infn,MODEXT,LIBEXT))		  /* Libraryname ?	  */
	  lib =	YES;
	else
	  lib =	NO;
	if (!*outfn)				  /* Ausgabedateiname =	  */
	  {					  /* erster Dateiname	  */
	    if (bin)				  /* Ausgabedateiname	  */
	      newfn(outfn,infn,BINEXT);		  /* mit Extension	  */
	    else				  /* entsprechend bin	  */
	      newfn(outfn,infn,COMEXT);		  /* versehen		  */
	  }
	if (lib)				  /* Libraries werden	  */
	  search();				  /* durchsucht,	  */
	else					  /* sonstige Module	  */
	  {					  /* werden ganz geladen  */
	    if (!(inrel	= fopen(infn,"rb")))	  /* Moduldatei	oeffnen	  */
	      fatal(infn," - Cannot open");
	    getname();				  /* Programmname holen	  */
	    load();				  /* Modul laden	  */
	    link();				  /* und linken		  */
	    fclose(inrel);
	  }
      }	/* end noch Argumente vorhanden	*/
    if (!*outfn) usage();		     /*	kein Dateiname angegeben  */
    csize = cloc;			     /*	Codelaenge und		  */
    dsize = dloc;			     /*	Datenlaenge merken	  */
    crend = crnext;			     /*	Tabellenende Indizes rel. */
    crnext = crstart;			     /*	Eintraege merken/ruecks.  */
    printf("%5d	bytes data\n",dsize);	     /*	Code- und Datenlaenge	  */
    printf("%5d	bytes code\n",csize);	     /*	ausgeben		  */
  }



/* Ende	von LNK2.C */
