/**************************************************************************\
*									   *
*   LNK3.C   -	  unido	X-Mac, Linker, Teil 3 von 3			   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include "all.h"			/* allgemeine Festlegungen	  */
#include "lnk.h"			/* Definitionen	fuer Linker	  */
#include "lnke.h"			/* Externals LNK.C		  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"
#include "rele.h"			/* Externals REL.C		  */


/*------------------------------------------------------------------------*/
/*--- Deklaration lokaler Funktionen				       ---*/
/*------------------------------------------------------------------------*/
void getcref __ARGS((void));
void getdref __ARGS((void));
void newfn __ARGS((char	*, char	*, char	*));
void prisym __ARGS((char *));


/**************************************************************************\
*									   *
* action      :	 Geladenen und gelinkten Code und Daten	absolut	machen und *
*		 im COM- oder BIN-Format auf Ausgabedatei(en) schreiben.   *
*									   *
*		   COM-Format: Programm	fuer COMBASE gelinkt		   *
*									   *
*		   BIN-Format: Programm	an in Kommandozeile angegebene	   *
*			       Stelle gelinkt				   *
*									   *
*		 Es werden Code- und ggf. Datenfile erstellt, es wird eine *
*		 Symboltabelle ausgegeben, wenn	monitor	eingeschaltet ist. *
*									   *
*		 Bei Angabe eines Programmstarts im Code und COM-Format	   *
*		 wird ein JP an	den Programmstart am Anfang eingefuegt.	   *
*									   *
*		 Programmabbruch mit Meldung, wenn das Ausgabefile nicht   *
*		 erzeugt werden	kann oder bei Schreibfehler auf	das	   *
*		 Ausgabefile.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 cbuffer  -  Basisadresse Code/Datenbuffer		   *
*		 cbase	  -  Codebereichsanfangsadresse	nach Linken	   *
*		 dbase	  -  Datenbereichsanfangsadresse nach Linken	   *
*		 csize	  -  Laenge Codebereich				   *
*		 dsize	  -  Laenge Datenbereich			   *
*		 start	  -  relative Programmstartadresse, falls im Code  *
*			     angegeben					   *
*		 bin	  -  YES: BIN-Format				   *
*		 data	  -  YES: extra	Datenfile erzeugen		   *
*		 crstart  -  Zeiger auf	Basis der Symboltabelle		   *
*		 epfirst  -  Index in Symboltabelle auf	Anfang		   *
*			     Einsprungpunkte				   *
*									   *
* r/w globals :	 outfn	  -  Dateispezifikation	Ausgabedatei, fuer	   *
*			     Codefile unveraendert, fuer Datendatei mit	   *
*			     Extension DATEXT				   *
*		 outfile  -  outfn entsprechende Ausgabedatei		   *
*		 cloc	  -  relative aktuelle Lokation	im Code		   *
*		 dloc	  -  relative aktuelle Lokation	in Daten	   *
*		 field	  -  aktuelles relative	Element			   *
*		 ref	  -  (siehe getref())				   *
*		 type	  -	"					   *
*		 xrplus	  -	"					   *
*									   *
* locals      :	 ptr	  -  Zeiger in cbuffer				   *
*		 n	  -  Formatzaehler fuer	Symboltabelle		   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

void phase2()
  {
    char   *ptr;
    int	    n;



    /* Codefile	(.COM oder .BIN) erzeugen */

    if (!(outfile = fopen(outfn,"wb")))	/* Datei anlegen		  */
      fatal(outfn," - Cannot create");	/* Fehler dabei			  */
    if (start && !bin)
      {					/* COM-Datei mit JP zum	Start :	  */
	putc(0xC3,outfile);		/*   JP				  */
	start += cbase;			/*   Startadresse absolut	  */
	putc(start,outfile);		/*   low Byte /	high Byte	  */
	putc(start >> 8,outfile);	/*   schreiben			  */
      }
    ptr	= cbuffer;			/* schneller als Pointerarithm.	  */
    cloc = -1;				/* im 1. Schleifendurchgang = 0	  */
    getcref();				/* ersten rel. Bezug holen	  */
    while (++cloc < csize)		/* solange noch	Code da		  */
      {
	if (cloc != ref)		/* relativer Bezug im Code ?	  */
	  {				/* kein	relativer Bezug	:	  */
	    putc(*ptr++,outfile);	/*   Byte holen	und schreiben	  */
	    continue;			/*   naechstes Byte/Word	  */
	  }
	field =	getuint(ptr);		/* naechstes relative Element :	  */
	switch (type)
	  {
	    case DREL :	 field = (CDBSZ	- 1 - field) + dbase;	  break;
	    case PREL :	 field = field + cbase;			  break;
	    case ABS  :	 field = (field	<< 8) |	((field	>> 8) &	0xFF);	break;
	  }
	field += xrplus;		/*   ggf. Offset dazu		  */
	putc(field,outfile);		/*   als low Byte / high Byte	  */
	putc(field >> 8,outfile);	/*   schreiben			  */
	getcref();			/*   naechsten rel. Bezug holen	  */
	++cloc;				/*   waren 2 Byte im Code	  */
	ptr += 2;
      }
    if (ferror(outfile))		     /*	Schreibfehler ?		  */
      fatal(outfn," - Error Writing");	     /*	ja   - Programmabbruch	  */
    if (data ||	!dsize)	fclose(outfile);     /*	nein - ggf. Fileende	  */



    /* Datenfile erzeugen (.DAT) */

    if (dsize)
      {
       crnext =	crstart;			  /* cr-Buffer von vorn	  */
	if (data)
	  {
	    newfn(outfn,outfn,DATEXT);		  /* ggf. DAT-Datei	  */
	    if (!(outfile = fopen(outfn,"wb")))
	      fatal(outfn," - Cannot create");
	  }
	ptr = dbuffer;				  /* s.o.		  */
	dloc = -1;
	getdref();
	while (++dloc <	dsize)
	  {
	    if (dloc !=	ref)
	      {
		field =	*ptr--;
		putc(field,outfile);
		continue;
	      }
	    field = getuint(ptr	- 1);
	    switch (type)
	      {
		case DREL :  field = (CDBSZ - 1	- field) + dbase;     break;
		case PREL :  field = field + cbase;		      break;
		case ABS  :  field = (field << 8) | ((field >> 8) & 0xFF);  break;
	      }
	    field += xrplus;
	    putc(field,outfile);
	    putc(field >> 8,outfile);
	    getdref();
	    ++dloc;
	    ptr	-= 2;
	  }
	if (ferror(outfile))
	  fatal(outfn,"	- Error	Writing");
	fclose(outfile);
      }



    /* Symboltabelle anzeigen */

    if (monitor)
      {
	printf("\n\nsymbols:\n\n");
	ptr = crstart +	(long)getuint(epfirst);
	n = 0;
	while (*(ptr + SYM) != HIGH)
	  {
	    field = getuint(ptr	+ VAL);
	    switch (*(ptr + TYP))
	      {
		 case DREL :  field += dbase;  break;
		 case PREL :  field += cbase;  break;
	      }
	    printf("%04x ",field);
	    prisym(ptr + SYM);
	    ptr	= crstart + (long)getuint(ptr);
	    if (++n == 3)
	      {
		n = 0;
		puts("");
	      }
	  }
	puts("");
      }
  }





/**************************************************************************\
*									   *
* action      :	 Code/Datenbufferrelativen Bezug word (Adresse oder	   *
*		 Offset) mit Typ t in den code/datenrelativen Indexbuffer  *
*		 schreiben. Bei	Ueberlauf des Buffers Meldung und	   *
*		 Programmabbruch.					   *
*									   *
*		 Es werden ein Byte Typ	und danach 2 Byte Adresse/Offset   *
*		 im Buffer abgelegt.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 word	 -  einzutragende Adresse/Offset		   *
*		 t	 -  einzutragender Typ				   *
*									   *
* r/o globals :	 snext	 -  hier: Ende des Buffers			   *
*									   *
* r/w globals :	 crnext	 -  naechste freie Stelle im Buffer		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

void putwcr(t,word)

unsigned t;
unsigned word;

  {
    *crnext++ =	t;				  /* ein Eintrag: Typ +	  */
    putuint(crnext,word);			  /* Adresse/Offset	  */
    if ((crnext	+= INTSZ) > snext)		  /* Ueberlaufcheck	  */
      fatal("Relative index memory overflow","");
  }





/**************************************************************************\
*									   *
* action      :	 Holen eines relativen Bezuges in ref, type, xrplus aus	   *
*		 dem code/datenrelativen Indexbuffer.			   *
*									   *
*		 getref()  :  xrnext zeigt auf zu holenden Bezug.	   *
*									   *
*		 getcref() :  xrnext zeigt auf naechsten zu untersuchenden *
*			      Bezug, es	wird der naechste coderelative	   *
*			      Bezug ab xrnext geholt.			   *
*									   *
*		 getdref() :  xrnext zeigt auf naechsten zu untersuchenden *
*			      Bezug, es	wird der naechste datenrelative	   *
*			      Bezug ab xrnext geholt.			   *
*									   *
*		 Ist der Buffer	ueberhaupt leer, wird type 0 und	   *
*		 ref = 0xFFFF.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 crend	 -  Ende des code/datenrelativen Indexbuffers	   *
*									   *
* r/w globals :	 ref	 -  die	geholte	Adresse				   *
*		 type	 -  Typ	des geholten Index, bei	getcref() und	   *
*			    getdref() nur RELBITS gesetzt		   *
*		 xrplus	 -  geholter Offset, wenn XRPBIT im Typfeld	   *
*			    gesetzt ist					   *
*		 crnext	 -  Zeiger auf naechsten zu untersuchender Eintrag *
*			    im code/datenrelativen Indexbuffer,	nach dem   *
*			    Holen Zeiger auf naechsten Eintrag		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/



void getref()
  {
    xrplus = 0;
    if (crnext >= crend)		     /*	zur Sicherheit,	wenn	  */
      {					     /*	keine relativen	Eintraege */
	ref = 0xFFFF;			     /*	in irgendeinem Segment	  */
	type = 0;			     /*	(gegen Endlosschleife)	  */
	return;
      }
    if ((type =	*crnext++ & 0xFF) & XRPBIT)  /*	Typ holen, wenn	XRPBIT	  */
      {					     /*	auch Offset holen und	  */
	xrplus = getuint(crnext);	     /*	dann eigentlichen Typ der */
	crnext += INTSZ;		     /*	Adresse			  */
	type = *crnext++ & 0xFF;
      }
    ref	= getuint(crnext);		     /*	Referenzadresse	holen	  */
    crnext += INTSZ;			     /*	naechster Eintrag	  */
  }



void getcref()				     /*	naechsten coderelativen	  */
  {					     /*	Bezug holen		  */
    do { getref(); } while (type & DSEGBIT); /*	solange	datenrelativ ...  */
    type &= RELBITS;			     /*	nur RELBITS als	Typ	  */
  }



void getdref()				     /*	naechsten datenrelativen  */
  {					     /*	Bezug holen		  */
    do { getref(); } while (type & CSEGBIT); /*	solange	coderelativ ...	  */
    type &= RELBITS;			     /*	nur RELBITS als	Typ	  */
  }





/**************************************************************************\
*									   *
* action      :	 Externen Bezug	auf Symbol aufloesen.			   *
*									   *
*		 Im Code/Datenbuffer die Referenzenkette (Eintrag xrnext)  *
*		 mit dem Einsprungpunkt	epnext so aufloesen, dass beim	   *
*		 Absolutmachen des Codes / der Daten die endgueltigen	   *
*		 Absolutadressen herauskommen.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 xrnext	  -  Zeiger in Symboltabelle auf Eintrag Ketten-   *
*			     anfang der	Kette der Referenzenkette	   *
*		 epnext	  -  Zeiger in Symboltabelle auf Eintrag	   *
*			     Einsprungpunkt, mit dem die Referenz	   *
*			     aufgeloest	wird				   *
*		 cbuffer  -  Basis des Code- und Datenbuffers		   *
*		 dbase	  -  Adresse Datenbereich nach Linken		   *
*		 cbase	  -  Adresse Codebereich nach Linken		   *
*		 dbnext	  -  Grenze Code/Daten im Code + Datenbuffer	   *
*									   *
* r/w globals :	 (Eintraege im Code/Datenbuffer)			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

void resolve()
  {
    unsigned nxt;	 /* Index naechstes zu ersetzendes Kettenglied	  */
    unsigned xr;	 /* Index zu ersetzendes Kettenglied		  */
    unsigned ep;	 /* aktuell einzusetzender ep			  */
    unsigned epa;	 /* absoluter Wert des ep nach Absolutmachung	  */

			 /* beim spaeteren Vorgang des Absolutmachens	  */
			 /* werden auch	die Kettenglieder einer	External- */
			 /* Kette bis auf das letzte noch einmal absolut  */
			 /* gemacht, die Werte jedes Gliedes muessen also */
			 /* so gesetzt werden, dass danach der richtige	  */
			 /* Wert herauskommt :				  */
    unsigned epp;	 /*   ep wenn Kettenglied programmrelativ	  */
    unsigned epd;	 /*   ep wenn Kettenglied datenrelativ		  */



    if (!(xr = getuint(xrnext +	VAL)))	/* Anfang der Verweisungskette	  */
      return;				/* nur definiert, keine	Kette	  */
    if (*(xrnext + TYP)	== DREL)	/* Datenindex			  */
      xr = CDBSZ - 1 - xr;


    /* Prog.-Link = "x + cbase", Daten-Link = "CDBSZ - 1 - x + dbase"	  */

    ep = getuint(epnext	+ VAL);		/* Adresse des Einsprungpunktes	  */
    switch (*(epnext + TYP))
      {
	case PREL :  epa = ep +	cbase;		       /* abs. Code <---+ */
		     epp = ep;			       /* Prog-Link  -->| */
		     epd = CDBSZ-1-ep -	cbase +	dbase; /* Daten-Link -->| */
		     break;

	case DREL :  epa = ep +	dbase;		       /* abs. Code <---+ */
		     epp = ep +	dbase -	cbase;	       /* Prog-Link  -->| */
		     epd = CDBSZ-1-ep;		       /* Daten-Link -->| */
		     break;

	case ABS  :  epa = ep;			       /* abs. Code <---+ */
		     epp = ep -	cbase;		       /* Prog-Link  -->| */
		     epd = CDBSZ-1-ep +	dbase;	       /* Daten-Link -->| */
		     break;
      }


    do						  /* fuer gesamte Kette	  */
      {

	if (cbuffer + (long)xr > dbnext)
	  nxt =	getuint(cbuffer	+ (long)xr - 1);	     /*	Datenindex	*/
	else
	  nxt =	getuint(cbuffer	+ (long)xr);		     /*	Codeindex	*/

	ep =  (cbuffer + (long)nxt > dbnext) ? epd : epp;

	if (nxt	== 0)				       /* Kettenende abs. */
	  {
	   if (cbuffer + (long)xr > dbnext)
	      {					/* xr-Ende im Datenfeld	: */
		*(cbuffer + (long)xr)	  = epa;      /*   low Byte / high Byte	*/
		*(cbuffer + (long)xr - 1) = epa	>> 8; /*   aber	Datenidx revers	*/
	      }
	    else
	      {					/* xr-Ende im Codefeld :  */
		*(cbuffer + (long)xr)	  = epa;      /*   low Byte / high Byte	*/
		*(cbuffer + (long)xr + 1) = epa	>> 8;
	      }
	  }
	else
	  if (cbuffer +	(long)xr > dbnext)	   /* kein Kettenende :		*/
	    putuint((long)xr + cbuffer - 1,ep);	   /*	Eintrag	im Datenfeld	*/
	  else
	    putuint((long)xr + cbuffer,ep);	   /*	Eintrag	im Codefeld	*/

      }	while ((xr = nxt) != 0); /* not 'TRUE' ! ACZ */
  }





/**************************************************************************\
*									   *
* action      :	 Library durchsuchen nach unaufgeloesten Referenzen,	   *
*		 Module	mit entsprechenden Einsprungpunkten laden,	   *
*		 Library solange durchsuchen, bis alle Referenzen	   *
*		 aufgeloest sind oder bei einem	Durchlauf		   *
*		 keine Module mehr aus der Library geladen wurden.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 infn	 - Dateiname der zu durchsuchenden Library	   *
*		 xrfirst - Zeiger auf Listenanfang unaufgeloeste Externals *
*									   *
* r/w globals :	 (siehe	getname(), getrel(), link(), load())		   *
*		 inrel	 - LIB-Dateizeiger				   *
*									   *
* locals      :	 linked	 - YES:	mind. ein Modul	in Durchlauf wurde gelinkt *
*			   NO :	kein Modul in Durchlauf	wurde gelinkt	   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

void search()
  {
    BOOLEAN linked;

    linked = NO;			/* noch	kein Modul gelinkt	  */
    if (!(inrel	= fopen(infn,"rb")))	/* LIB-Datei oeffnen		  */
      fatal(infn," - Cannot open");	/* ... Programmabbruch bei Fehler */
    LOOP				/* so lange durchgehen bis fertig */
      {
	while (getname())		/* auf naechstes Modul		  */
	  {				/* positionieren		  */
	    while (getrel() == ENAME)	/* ganze Globalliste/Modul	  */
	      {				/* untersuchen			  */
		if (isunres())		/* wenn	nicht aufgeloeste	  */
		  {			/* Referenz, dann		  */
		    load();		/* Modul laden			  */
		    link();		/* und linken			  */
		    linked = YES;	/* Flag: Modul gelinkt		  */
		    break;		/* Rest	Globalliste unnoetig,	  */
		  }			/* Modul ist ja	gelinkt	worden	  */
	      }
	  }
	if (	!linked			     /*	wenn kein Modul	aus	  */
	     ||	*(   crstart		     /*	Library	geladen	oder alle */
		   + (long)getuint(xrfirst + NXT)  /* Referenzen aufgeloest,	*/
		   + SYM		     /*	dann war's das		  */
		 ) == HIGH
	   ) break;
	linked = NO;			/* neuen Durchlauf starten,	  */
	rewind(inrel);			/* LIB-File von	vorn durchgehen	  */
      }	/* end LOOP */
    fclose(inrel);			/* LIB-File schliessen		  */
  }





/**************************************************************************\
*									   *
* action      :	 Neue Dateispezifikation aus alter erstellen.		   *
*									   *
*		 Die alte Dateispezifikation besteht aus Weg, Dateiname	   *
*		 und ggf. Extension. Der neue Dateiname	beeinhaltet den	   *
*		 Weg und Dateinamen, aber Extension ext. Es werden Datei-  *
*		 namen der Formen					   *
*									   *
*		   <drive>:\<subdir 1>\	... \<subdir n>\<name>.<extension> *
*		   <drive>:/<subdir 1>/	... /<subdir n>/<name>.<extension> *
*		   .\<subdir 1>\ ... \<subdir n>\<name>.<extension>	   *
*		   ./<subdir 1>/ ... /<subdir n>/<name>.<extension>	   *
*									   *
*		   (Subdirectories, Extension, Driveangaben optional)	   *
*									   *
*		 unterstuetzt.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 dest	-  Zieldateiname, muss sour (- Extension) + ext	   *
*			   aufnehmen koennen				   *
*		 sour	-  Quelldateiname mit Extension			   *
*		 ext	-  neue	Extension				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 ppos	-  Index '.' in	sour				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

void newfn(dest, sour, ext)
char *dest, *sour, *ext;
  {
    int	ppos;

    strcpy(dest,sour);				  /* Spezif. kopieren	  */
    ppos = strlen(dest)	- 1;			  /* Index letzt. Zeichen */
    while (    ppos > 0				  /* Extension-Punkt	  */
	    && dest[ppos] != '\\'		  /* finden, Suche von	  */
	    && dest[ppos] != '/'		  /* hinten, da	auch z.B. */
	    && dest[ppos] != '.' ) --ppos;	  /* ".\ABC.EXT" gueltig  */
    if (dest[ppos] == '.') dest[ppos] =	'\0';	  /* alte Ext. loeschen	  */
    strcat(dest,ext);				  /* neue Ext. anhaengen  */
  }





/**************************************************************************\
*									   *
* action      :	 Falls Dateispezifikation keine	Extension hat, bekommt sie *
*		 sie ext1. Hat sie eine, dann muss diese entweder ext1	   *
*		 oder ext2 entsprechen.					   *
*									   *
*		 Programmabbruch mit Meldung bei zu langer Spezifikation   *
*		 oder vorhandener nicht	ext1 oder ext2 entsprechender	   *
*		 Extension.						   *
*									   *
*		 Dateispezifikationen wie in newfn().			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 fn	-   Dateiname					   *
*		 ext1	-   1. Extension				   *
*		 ext2	-   2. Extension				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 YES, wenn Extension ext2 entspricht und NO sonst	   *
*									   *
\**************************************************************************/

BOOLEAN	extend(fn,ext1,ext2)

char *fn;
char *ext1;
char *ext2;

  {
    char   *cp;					  /* Zeiger in fn	  */

    cp = fn + strlen(fn) - 1;			  /* Extension-Punkt	  */
    while (	cp != fn			  /* finden (Suche von	  */
	    && *cp != '\\'			  /* hinten, da	auch z.B. */
	    && *cp != '/'			  /* ".\ABC.EXT" gueltig) */
	    && *cp != '.' ) --cp;
    if (*cp == '.')				  /* Extension vorhanden  */
      {
	if (strcmp(cp,ext2) == 0) return (YES);	  /* = ext2, ok		  */
	if (strcmp(cp,ext1) == 0) return (NO);	  /* !=	ext2, != ext1,	  */
	fatal(fn," - Invalid extension");	  /* Fehler, Abbruch	  */
      }
    if (strlen(fn) + strlen(ext1) > FNSIZE)	  /* Laengencheck	  */
      fatal(fn," - Too long");
    strcat(fn,ext1);				  /* ext1 anhaengen	  */
    return(NO);
  }





/**************************************************************************\
*									   *
* action      :	 Symbolstring sym linksbuendig in einem	10-Zeichen-Feld	   *
*		 ausgeben (Name	+ Spaces) an stdout.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 sym	-   Zeiger auf nullterminierten	Symbolstring,	   *
*			    Laenge muss	kleiner	gleich 10 sein		   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 n	-  Formatzaehler				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

void prisym(sym)
char *sym;
  {
    int	n;

    n =	17;				/* feste Feldlaenge		 */
    while (*sym)			/* Symbol ausgeben		 */
      {
	putchar(*sym++);
	--n;				/* Feldlaengenzaehler		 */
      }
    while (n)				/* Feld	mit Spaces auffuellen	 */
      {
	putchar(' ');
	--n;
      }
  }





/**************************************************************************\
*									   *
* action      :	 NUR ZUM DEBUGGEN DES LINKERS SELBST.			   *
*									   *
*		 Kompletten Dump aller Variablen und Speicherstrukturen	   *
*		 an stdout ausfuehren mit Ueberschrift sign.		   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 sign  -  Ueberschrift ueber dem Dump			   *
*									   *
* r/o globals :	 (alle LNK-spezifischen)				   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/


/*
void dumpall(sign)

char *sign;

  {
    int		n;
    unsigned	idx;
    char       *ptr;

    unsigned	refsav;
    unsigned	xrpsav;
    unsigned	typsav;
    char       *crnsav;
    char       *cresav;



    printf("\n\nDEBUG dump, %s :\n\n",sign);

    printf("	   bin	   %04x	     data     %04x\n",bin,data);
    printf("   monitor	   %04x	  cbuffer %08lx\n",monitor,cbuffer);
    printf("	cbnext %08lx   dbuffer %08lx\n",cbnext,dbuffer);
    printf("	dbnext %08lx	 snext %08lx\n",dbnext,snext);
    printf("	 sfree	   %04x	  crstart %08lx\n",sfree,crstart);
    printf("	crnext %08lx	 crend %08lx\n",crnext,crend);
    printf("   epfirst %08lx	epnext %08lx\n",epfirst,epnext);
    printf("   xrfirst %08lx	xrnext %08lx\n",xrfirst,xrnext);
    printf("   loading	   %04x	    cbase     %04x\n",loading,cbase);
    printf("	  cloc	   %04x	     cmod     %04x\n",cloc,cmod);
    printf("	 csize	   %04x	    dbase     %04x\n",csize,dbase);
    printf("	  dloc	   %04x	     dmod     %04x\n",dloc,dmod);
    printf("	 dsize	   %04x	      ref     %04x\n",dsize,ref);
    printf("	xrplus	   %04x	    start     %04x\n",xrplus,start);
    printf("   modname %s\n",modname);
    printf("	  infn %s\n",infn);
    printf("	 outfn %s\n",outfn);



    printf("\ncode buffer (cbuffer/cbnext)\n");
    for	( idx =	0, ptr = cbuffer;
	  ptr <= cbnext;
	  idx += 16, ptr += 16
	)
      {
	printf("%04x",idx);
	for (n = 0; n <	16; ++n) printf(" %02x",*(ptr +	n) & 0xFF);
	printf("\n");
      }

    printf("\ndata buffer (dbuffer/dbnext)\n");
    for	( idx =	(dbnext	- cbuffer) & 0xFFF0, ptr = cbuffer + (long)idx;
	  ptr <= dbuffer;
	  idx += 16, ptr += 16
	)
      {
	printf("%04x",idx);
	for (n = 0; n <	16; ++n) printf(" %02x",*(ptr +	n) & 0xFF);
	printf("\n");
      }


    refsav = ref;
    xrpsav = xrplus;
    typsav = type;
    crnsav = crnext;
    cresav = crend;
    printf("\nrelative index buffer (crstart/crnext/crend)\n");
    if (crnext > crend)	crend =	crnext;
    crnext = crstart;
    n =	0;
    while (crnext < crend)
      {
	getref();
	if (xrplus)
	  {
	    printf(" %04x+ ",xrplus);
	    if (++n == 10)
	      {
		n = 0;
		puts("");
	      }
	  }
	switch (type & SEGBITS)
	  {
	    case CSEGBIT :  putchar('\'');  break;
	    case DSEGBIT :  putchar('"');   break;
	    default	 :  putchar('?');   break;
	  }
	printf("%04x",ref);
	switch (type & RELBITS)
	  {
	    case PREL :	 printf("' ");	 break;
	    case DREL :	 printf("\" ");	 break;
	    case ABS  :	 printf("  ");	 break;
	    default   :	 printf("? ");	 break;
	  }
	if (++n	== 10)
	  {
	    n =	0;
	    puts("");
	  }
      }
    if (n) puts("");
    ref	   = refsav;
    xrplus = xrpsav;
    type   = typsav;
    crnext = crnsav;
    crend  = cresav;

    printf("\nentry points (epfirst)\n");
    ptr	= crstart + (long)getuint(epfirst);
    n =	0;
    while (*(ptr + SYM)	!= HIGH)
      {
	printf("%04x",getuint(ptr + VAL));
	switch (*(ptr +	TYP))
	  {
	    case PREL :	 putchar('\'');	 break;
	    case DREL :	 putchar('"');	 break;
	    case ABS  :	 putchar(' ');	 break;
	    default   :	 putchar('?');	 break;
	  }
	printf(" ");
	prisym(ptr + SYM);
	if (++n	== 3)
	  {
	    n =	0;
	    puts("");
	  }
	ptr = crstart +	(long)getuint(ptr);
      }
    if (n) puts("");

    printf("\nexternals	(xrfirst)\n");
    ptr	= crstart + (long)getuint(xrfirst);
    n =	0;
    while (*(ptr + SYM)	!= HIGH)
      {
	printf("%04x",getuint(ptr + VAL));
	switch (*(ptr +	TYP))
	  {
	    case PREL :	 putchar('\'');	 break;
	    case DREL :	 putchar('"');	 break;
	    case ABS  :	 putchar(' ');	 break;
	    default   :	 putchar('?');	 break;
	  }
	printf(" ");
	prisym(ptr + SYM);
	if (++n	== 3)
	  {
	    n =	0;
	    puts("");
	  }
	ptr = crstart +	(long)getuint(ptr);
      }
    if (n) puts("");

    printf("\n\n\n");
  }
*/


/* Ende	von LNK3.C */
