/**************************************************************************\
*									   *
*   MAC.H   -	unido X-Mac, Headerdatei X-Mac				   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*						vermischte Definitionen	  */
/**************************************************************************/

#define	MAXLAB	  15	      /* Maximallaenge eines Labels		  */
#define	MICOUNT	  150	      /* Hash-Raum fuer	Maschineninstruktionen	  */





/*							  Symboltabelle	  */
/**************************************************************************/

#define	STMAX	  1000			/* Maximalzahl der Symbole	  */
#define	STVALUE	  (MAXLAB + 1)		/* Offset in das Werte-Feld	  */
#define	STFLAG	  (STVALUE + INTSZ)	/* Offset zum Flag-Byte		  */
#define	STENTRY	  (STFLAG + 1)		/* Groesse eines Eintrags in st	  */
#define	STBUFSZ	  (STMAX * STENTRY)	/* Puffergroesse st		  */
					/* ACHTUNG: muss < 64k sein !	  */

					/* st-Eintrag, Bits an STFLAG :	  */
#define	LABBIT2	  0x80			/*   Label-Flag	(Pass 2)	  */
#define	LABBIT	  0x40			/*   Label-Flag			  */
#define	EQUBIT	  0x20			/*   EQU-Flag (Pass 2)		  */
#define	SETBIT	  0x10			/*   SET-Flag			  */
#define	XRBIT	  0x08			/*   Flag fuer externe Referenz	  */
#define	EPBIT	  0x04			/*   Flag fuer Einsprungpunkt	  */
#define	RELBITS	  0x03			/*   relative Bits (ABS, PREL)	  */





/*							   Makrotabelle	  */
/**************************************************************************/

#define	MTBUFSZ	  10000			 /* Groesse Makrotabelle in Bytes */
					 /* ACHTUNG: muss < 64k	sein !	  */
#define	MTNXT	  0			 /* Zeiger auf naechsten Makro	  */
#define	MTNAM	  INTSZ			 /* Makroname			  */





/*						  Codes	fuer Pseudo-Ops	  */
/**************************************************************************/

#define	DW	   1	      /* DW, DEFW				  */
#define	DB	   2	      /* DB, DEFB				  */
#define	DS	   3	      /* DS, DEFS				  */
#define	EX	   4	      /* EXT, EXTRN, EXTERNAL			  */
#define	SET	   5	      /* SET					  */
#define	EQU	   6	      /* EQU					  */
#define	ORG	   7	      /* ORG					  */
#define	END	   8	      /* END					  */
#define	MACRO	   9	      /* MACRO					  */
#define	REPT	  10	      /* REPT					  */
#define	ENDM	  11	      /* ENDM					  */
#define	CALL	  12	      /* (Makroaufruf)				  */
#define	CSEG	  13	      /* CSEG					  */
#define	DSEG	  14	      /* DSEG					  */
#define	GLOBAL	  15	      /* GLOBAL, PUBLIC				  */
#define	IGNORE	  16	      /* zu ignorierender Pseudo-Operand, .Z80	  */





/*						     Ausdruckauswertung	  */
/**************************************************************************/

			      /* Token in einem	Ausdruck :		  */
#define	OR	 1	      /*   |   - bitweises Oder			  */
#define	XOR	 2	      /*   ^   - bitweises Exklusiv-Oder	  */
#define	AND	 3	      /*   &   - bitweises Und			  */
#define	EQ	 4	      /*   ==  - gleich				  */
#define	NE	 5	      /*   !=  - ungleich			  */
#define	LE	 6	      /*   <=  - kleiner gleich			  */
#define	GE	 7	      /*   >=  - groesser gleich		  */
#define	LT	 8	      /*   <   - kleiner			  */
#define	GT	 9	      /*   >   - groesser			  */
#define	RSH	10	      /*   >>  - bitweises Rechtsschieben	  */
#define	LSH	11	      /*   <<  - bitweises Linksschieben	  */
#define	PLUS	12	      /*   +   - Addition			  */
#define	MINUS	13	      /*   -   - Subtraktion			  */
#define	MULT	14	      /*   *   - Multiplikation			  */
#define	DIV	15	      /*   /   - Division			  */
#define	MOD	16	      /*   %   - Modulo				  */
#define	CPL	17	      /*   ~   - bitweises Invertieren		  */
#define	NOT	18	      /*   !   - logisches Nicht		  */
#define	LPN	19	      /*   (   - Klammer auf			  */
#define	RPN	20	      /*   )   - Klammer zu			  */
#define	LOC	21	      /*   $   - Programmzaehler		  */
#define	SYM	22	      /*   Symbol				  */
#define	NUM	23	      /*   Zahl					  */
#define	EOE	24	      /*   Ende	des Ausdrucks			  */



/* Ende	von MAC.H */
