/**************************************************************************\
*									   *
*   MAC5.C   -	 unido X-Mac, Teil 5 von 5				   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include <ctype.h>
#include "all.h"			/* allgemeine Festlegungen	  */
#include "mac.h"			/* Festlegungen	fuer MAC	  */
#include "mace.h"			/* Externals MAC		  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"
#include "rele.h"			/* Externals REL.C		  */


/*----------------------------------------------------------------------*/
/* Test, ob Character c	fuer ein Label ein legales Zeichen ist		*/
/*----------------------------------------------------------------------*/
BOOLEAN	islabel(c) 
char c;
{
  if (isalnum(c)) return(TRUE);
  if (c	== '$')	return(TRUE);
  if (c	== '@')	return(TRUE);
  if (c	== '?')	return(TRUE);
  if (c	== '_')	return(TRUE);

  return(FALSE);
}


/**************************************************************************\
*									   *
* action      :	 Wertet	den naechsten an ep stehenden Ausdruck aus,	   *
*		 ep wird von der rufenden Funktion gesetzt.		   *
*		 Setzt bei Fehlern im Ausdruck entsprechendes Fehlerflag.  *
*		 Zur Endlosschleifenvermeidung beim Fehler eines unaeren   *
*		 Operators (ep bliebe bestehen -> Schleife) wird ep bei	   *
*		 Fehlern ein Zeichen weiter gesetzt.			   *
*									   *
*		 Bei leeren Ausdruecken	wird absolut 0 als Ergebnis	   *
*		 gesetzt.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 value	-  Zeiger auf zu setzendes Ergebnis, Wert, nach	   *
*			   Ausdrucksauswertung				   *
*		 type	-  s.o., Typ					   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 ep	-  Zeiger auf auszuwertenden Ausdruck bei Eingang, *
*			   bei Ausgang Zeiger hinter ausgewerteten	   *
*			   Ausdruck					   *
*		 ct	-  aktuelles Token				   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID expr(value, type)
unsigned *value, *type;
  {
    ct = 0;				     /*	Start: noch kein Token	  */
    if (token(EOE))			     /*	Token holen,		  */
      {					     /*	wenn Ausdruck leer,	  */
	*value = 0;			     /*	Ergebnis absolut 0	  */
	*type =	ABS;
	return;
      }
    if (!level1((int *)value, (int *)type) || ct != EOE)
					     /*	sonst Ausdruck auswerten  */
      {
	 if (*ep) ++ep;			     /*	bei Fehler ep weiter s.o. */
	 experr();			     /*	und Fehler melden	  */
      }
  }





/**************************************************************************\
*									   *
* action      :	 Primaere Ausdruecke (siehe primary()) und Ausdruecke mit  *
*		 unaeren Operatoren auswerten.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 v	-  Zeiger auf zu setzendes Ergebnis, Wert, nach	   *
*			   Ausdrucksauswertung				   *
*		 t	-  s.o., Typ					   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 YES:  die Auswertung und Berechnung konnte fehlerfrei	   *
*		       ausgefuehrt werden				   *
*		 NO :  es haben	sich Fehler ergeben bei	der Auswertung	   *
*		       oder Auswertung konnte nicht erfolgen		   *
*									   *
\**************************************************************************/

BOOLEAN	unary(v, t)
int *v, *t;
  {
    if (token(CPL))			     /*	~			  */
      {
	if (!unary(v,t)) return	(NO);
	*v = ~*v;
	goto check;
      }
    else
      if (token(NOT))			     /*	!			  */
	{
	  if (!unary(v,t)) return (NO);
	  *v = !*v;
	  goto check;
	}
      else
	if (token(MINUS))		     /*	-			  */
	  {
	    if (!unary(v,t)) return (NO);
	    *v = -*v;
	    check :
	    if (*t & RELBITS) relerr();	     /*	relokatibel nicht erlaubt */
	    *t &= ~RELBITS;		     /*	ABS erzwingen		  */
	    return (YES);		     /*	das ist	eigentlich falsch */
	  }
	else				     /*	kein unaerer Operator,	  */
	  return (primary(v,t));	     /*	primary	probieren	  */
  }





/**************************************************************************\
*									   *
* action      :	 Operatorhierarchische Auswertefunktionen, nach	Aufruf	   *
*		 wird jeweils eine Stufe tiefer	versucht auszuwerten.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 v	 -  Zeiger auf zu setzendes Ergebnis, Wert, nach   *
*			    Ausdrucksauswertung				   *
*		 t	 -  s.o., Typ					   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 YES:  die Auswertung und Berechnung konnte fehlerfrei	   *
*		       ausgefuehrt werden				   *
*		 NO :  es haben	sich Fehler ergeben bei	der Auswertung	   *
*		       oder Auswertung konnte nicht erfolgen		   *
*									   *
\**************************************************************************/

BOOLEAN	level8(v,t) int	*v; int	*t;  { return (down(l8ops, unary,v,t));	}
BOOLEAN	level7(v,t) int	*v; int	*t;  { return (down(l7ops,level8,v,t));	}
BOOLEAN	level6(v,t) int	*v; int	*t;  { return (down(l6ops,level7,v,t));	}
BOOLEAN	level5(v,t) int	*v; int	*t;  { return (down(l5ops,level6,v,t));	}
BOOLEAN	level4(v,t) int	*v; int	*t;  { return (down(l4ops,level5,v,t));	}
BOOLEAN	level3(v,t) int	*v; int	*t;  { return (down(l3ops,level4,v,t));	}
BOOLEAN	level2(v,t) int	*v; int	*t;  { return (down(l2ops,level3,v,t));	}
BOOLEAN	level1(v,t) int	*v; int	*t;  { return (down(l1ops,level2,v,t));	}





/**************************************************************************\
*									   *
* action      :	 Primaeren Ausdruck auswerten. Primaere	Ausdruecke sind	   *
*		 geklammerte Ausdruecke, Zahlen, Programmzaehler $,	   *
*		 Symbole.						   *
*									   *
*		 Wird ein neues	externes Symbol	gefunden, dieses in die	   *
*		 Symboltabelle aufnehmen.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 v	 -  Zeiger auf zu setzendes Ergebnis, Wert, nach   *
*			    Ausdrucksauswertung				   *
*		 t	 -  s.o., Typ					   *
*									   *
* r/o globals :	 number	 -  Zahl im Ausdruck nach getnum()		   *
*		 iloc	 -  aktueller Programmzaehlerstand		   *
*		 seg	 -  aktuelles Segment (PREL oder DREL)		   *
*		 stptr[] -  Eintrag in Symboltabelle			   *
*		 gotxr	 -  YES: gefundenes Symbol ist External		   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 ok	 -  Zwischenspeicher Zustand Auswertung		   *
*			    geklammerter Ausdruck			   *
*									   *
* returns     :	 YES:  die Auswertung und Berechnung konnte fehlerfrei	   *
*		       ausgefuehrt werden				   *
*		 NO :  es haben	sich Fehler ergeben bei	der Auswertung	   *
*		       oder Auswertung konnte nicht erfolgen		   *
*									   *
\**************************************************************************/

BOOLEAN	primary(v,t)

int *v;
int *t;

  {
    int	ok;

    if (token(LPN))			     /*	(			  */
      {
	ok = level1(v,t);		     /*	Ausdruck in Klammern aus- */
	if (token(RPN))	return (ok);	     /*	werten,	dann ) erwartet	  */
	return (NO);
      }
    *t = ABS;				     /*	Voreinstellung		  */
    *v = 0;
    if (token(NUM))			     /*	Zahl			  */
      {
	*v = number;
	return (YES);
      }
    else
      if (token(LOC))			     /*	$ (Programmzaehler)	  */
	{
	  *v = iloc;
	  *t = seg;
	  return (YES);
	}
      else
	{
	  if (token(SYM))		     /*	Symbol			  */
	    {
	      if (stfind())		     /*	in Symboltabelle ?	  */
		{
		  *t = stptr[STFLAG];		       /* ja, Typ holen	  */
		  if (!(stptr[STFLAG] &	XRBIT))	       /* kein External	: */
		    {				       /* Fehler wenn als */
		      if (gotxr) rederr();	       /* External gefun. */
		      *v = getuint(stptr + STVALUE);   /* Wert holen	  */
		    }
		  else goto doxr;	     /*	ist External		  */
		}
	      else			     /*	unbekannt, aber	als	  */
		if (gotxr)		     /*	External gefunden :	  */
		  {			     /*	neue ext. Ref. definieren */
		    addsym();		     /*	Symbol anlegen		  */
		    *t = XRBIT|ABS;	     /*	erste ext. Ref.	ist ABS	0 */
		    doxr :
		    if (pass ==	2)	     /*	Verkettung nur Pass 2 !	  */
		      {
			prior =	getuint(stptr +	STVALUE); /* alter Wert	  */
			priort = stptr[STFLAG];		  /* und Typ	  */
			putuint(stptr +	STVALUE,loc);	  /* neuer Wert	  */
			stptr[STFLAG]			  /* und Typ	  */
			   =   (stptr[STFLAG] &	~RELBITS)
			     | XRBIT | seg;
		      }
		  }
		else underr();
	      return (YES);
	    }
	}
    return (NO);			/* Auswertung nicht gelungen	  */
  }





/**************************************************************************\
*									   *
* action      :	 Ausdruck auswerten. Vor der eigentlichen Auswertung	   *
*		 wird die Auswertung eine Stufe	tiefer in der Hierarchie   *
*		 der Operatoren	versucht.				   *
*									   *
*		 Falls der Ausdruck gueltig ist, muss in jedem Fall eine   *
*		 tiefere Stufe eine Auswertung liefern,	naemlich einen	   *
*		 unaeren Ausdruck oder einen Wert (Symbol, Zahl, PC).	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 ops	-  Zeiger auf Operatortokenliste		   *
*		 level	-  Zeiger auf Auswertefunktion,	entsprechend	   *
*			   Tiefe der  Operatorhierarchie		   *
*		 v	-  Zeiger auf zu setzendes Ergebnis, Wert, nach	   *
*			   Ausdrucksauswertung				   *
*		 t	-  s.o., Typ					   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 op	-  Zeiger in Operandentokenliste		   *
*									   *
* returns     :	 YES:  die Auswertung und Berechnung konnte fehlerfrei	   *
*		       ausgefuehrt werden				   *
*		 NO :  es haben	sich Fehler ergeben bei	der Auswertung	   *
*		       oder Auswertung konnte nicht erfolgen		   *
*									   *
\**************************************************************************/

BOOLEAN	down(ops,level,v,t)

int *ops;
int (*level) __ARGS((int *, int *));
int *v;
int *t;

  {
    int	*op;

    if (!(*level)(v,t))	return (NO);	     /*	tiefere	Stufe probieren	  */
    op = --ops;				     /*	linke Seite ok,	Operator  */
    while (*++op)			     /*	suchen			  */
      {
	if (token(*op))				       /* wenn gefunden	  */
	  {					       /* rechte Seite	  */
	    if (!down2(*op,level,v,t)) return (NO);    /* dazu		  */
	    if (token(EOE)) return (YES);	       /* Ausdr.ende: ok  */
	    op = ops;				       /* sonst	weiter	  */
	  }					       /* probieren	  */
      }
    return (YES);			     /*	naechste Stufe		  */
  }





/**************************************************************************\
*									   *
* action      :	 Rechte	Seite eines Ausdrucks auswerten. Linke und rechte  *
*		 Seite mit Operator verknuepfen. Je nach Typ der Seiten	   *
*		 sind folgende Operationen zugelassen :			   *
*									   *
*		  a) <absolut> op <absolut>  : alle Operatoren,	Ergebnis   *
*					       absolut			   *
*									   *
*		  b) <absolut> op <relativ>  : nur Addition, Ergebnis	   *
*					       relativ			   *
*									   *
*		  c) <relativ> op <absolut>  : Addition	und Subtraktion,   *
*					       Ergebnis	relativ		   *
*									   *
*		  d) <relativ> op <relativ>  : nur Subtraktion und Ver-	   *
*					       gleiche,	Ergebnis absolut   *
*									   *
*									   *
* Da ein relativer Wert	kein negatives Vorzeichen bekommen kann, ist in	   *
* b) nur Addition zugelassen waehrend absolute Offsets zu relativen	   *
* Werten beliebige Vorzeichen haben duerfen, siehe c).			   *
*									   *
* Bei der Verknuepfung zweier relativer	Werte, d), sind	nur Vergleiche	   *
* sinnvoll und als einzige Rechenoperation Subtraktion,	nur bei	der	   *
* Subtraktion ergibt sich ein linkunabhaengiger	absoluter Wert,	alle	   *
* anderen Operationen sind linkabhaengig und muessen daher vermieden	   *
* werden.								   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 oper	-  Operatortoken des Operators,	mit dem	linker und *
*			   rechter Teil	des Ausdrucks verknuepft werden	   *
*			   sollen					   *
*		 level	-  Zeiger auf Auswertefunktion,	entsprechend	   *
*			   Tiefe der  Operatorhierarchie		   *
*		 v	-  Zeiger auf zu setzendes Ergebnis, Wert, nach	   *
*			   Ausdrucksauswertung				   *
*			   Eingang: *v enthaelt	Wert des linken	Teils des  *
*				    Ausdrucks				   *
*			   Ausgang: *v enthaelt	linken Wert verknuepft mit *
*				    rechtem Wert			   *
*		 t	-  s.o., Typ					   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 ok	-  Zustand Auswertung rechter Ausdrucksteil	   *
*		 vr	-  Zwischenspeicher Wert rechter Ausdrucksteil	   *
*		 tr	-  Zwischenspeicher Typ	rechter	Ausdrucksteil	   *
*		 tl	-  Zwischenspeicher Typ	linker Ausdrucksteil,	   *
*			   nur RELBITS					   *
*									   *
* returns     :	 YES:  die Auswertung und Berechnung konnte fehlerfrei	   *
*		       ausgefuehrt werden				   *
*		 NO :  es haben	sich Fehler ergeben bei	der Auswertung	   *
*									   *
\**************************************************************************/

BOOLEAN	down2(oper,level,v,t)

int oper;
int (*level) __ARGS((int *, int *));
int *v;
int *t;

  {
    int	ok;
    int	vr;
    int	tr;
    int	tl;

    ok = (*level)(&vr,&tr);		     /*	rechte Seite auswerten	  */
    *v = binary(*v,oper,vr);		     /*	Operator anwenden	  */
    tl = *t & RELBITS;			     /*	Rel.Typ	linke Seite	  */
    *t = (*t | tr) & ~RELBITS;		     /*	Gesamttyp ohne RELBITS	  */
    tr &= RELBITS;			     /*	Rel.Typ	rechte Seite	  */
    if (tl == ABS)			     /*	<rtyp?>	<oper> <rtyp?> :  */
      {
	if (tr == ABS)
	  return (ok);			     /*	abs <oper> abs		  */
	else				     /*	abs <oper> rel		  */
	  {
	    if (oper ==	PLUS)		     /*	  nur Addition zugelassen */
	      {
		*t |= tr;		     /*	  Rel.Typ gesamt = rechts */
		return (ok);
	      }
	    return (NO);		     /*	  keine	Addition, Fehler  */
	  }
      }
    else				     /*	rel <oper> abs		  */
      {
	if (tr == ABS)
	  {
	    switch (oper)
	      {
		case PLUS  :		     /*	  s.o.,	aber Addition und */
		case MINUS :		     /*	  Subtraktion zugelassen  */
		  *t |=	tl;
		  return (ok);
	      }
	    return (NO);
	  }
	else				     /*	rel <oper> rel		  */
	  if (tl == tr)			     /*	  beide	Operanden muessen */
	    {				     /*	  aus selbem Segment	  */
	      switch (oper)		     /*	  stammen, zugelassen	  */
		{			     /*	  dann nur Subtraktion,	  */
		  case MINUS :		     /*	  Vergleiche		  */
		  case EQ    :
		  case LT    :
		  case LE    :
		  case NE    :
		  case GT    :
		  case GE    :
		    return (ok);
		}
	      return (NO);
	    }
	  else return (NO);		/* verschiedene	Segmente, Fehler  */
      }
  }





/**************************************************************************\
*									   *
* action      :	 Binaeren Operator oper	anwenden auf Operanden left und	   *
*		 right.							   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 left	-  linker Operand				   *
*		 oper	-  Token des anzuwendenden binaeren Operators	   *
*		 right	-  rechter Operand				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 Ergebnis der Operation	oder 0 bei unbekanntem Operator	   *
*									   *
\**************************************************************************/

int binary(left,oper,right)

int left;
int oper;
int right;

  {
    switch (oper)
      {
	case OR	   :  return (left |  right);
	case XOR   :  return (left ^  right);
	case AND   :  return (left &  right);
	case EQ	   :  return (left == right);
	case NE	   :  return (left != right);
	case LE	   :  return (left <= right);
	case GE	   :  return (left >= right);
	case LT	   :  return (left <  right);
	case GT	   :  return (left >  right);
	case RSH   :  return (left >> right);
	case LSH   :  return (left << right);
	case PLUS  :  return (left +  right);
	case MINUS :  return (left -  right);
	case MULT  :  return (left *  right);
	case DIV   :  return (left /  right);
	case MOD   :  return (left %  right);
      }
    return (0);
  }





/**************************************************************************\
*									   *
* action      :	 Naechstes Token ausfindig machen und mit want		   *
*		 vergleichen. Wenn ct gesetzt ist, Token aus ct	nehmen.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 want	  -  gewuenschtes Token				   *
*									   *
* r/o globals :	 stsym[0] -  wird durch	getsy()	gesetzt, wenn != 0 wurde   *
*			     Symbol gefunden				   *
*									   *
* r/w globals :	 ct	  -  aktuelles Token, wenn 0 neues Token suchen	   *
*			     und ct zuordnen				   *
*		 ep	  -  Zeiger in Ausdruck	auf Stelle naechstes Token *
*									   *
* locals      :	 len	  -  wenn Token	Zahl, Zwischenspeicher Laenge	   *
*									   *
* returns     :	 YES:  gefundenes oder aktuelles Token gleich want	   *
*		 NO :  sonst						   *
*									   *
\**************************************************************************/

BOOLEAN	token(want)

int want;

  {
    int	len;

    if (ct) return (found(want,ct));	     /*	Token schon vorhanden	  */
    while (isspace(*ep)) ++ep;		     /*	auf naechstes Objekt	  */
    switch (*ep++)			     /*	auf Operator testen	  */
      {


	/* 1-Zeichen Operatoren	*/

	case '|' :  return (found(want,OR));
	case '^' :  return (found(want,XOR));
	case '&' :  return (found(want,AND));
	case '+' :  return (found(want,PLUS));
	case '-' :  return (found(want,MINUS));
	case '*' :  return (found(want,MULT));
	case '/' :  return (found(want,DIV));
	case '%' :  return (found(want,MOD));
	case '~' :  return (found(want,CPL));
	case '(' :  return (found(want,LPN));
	case ')' :  return (found(want,RPN));
	case '$' :  return (found(want,LOC));
	case ',' :  return (found(want,EOE));


	/* 2-Zeichen Operatoren	*/

	case '!' :  if (*ep++ == '=') return (found(want,NE));	--ep;
				      return (found(want,NOT));
	case '<' :  if (*ep++ == '=') return (found(want,LE));	--ep;
		    if (*ep++ == '<') return (found(want,LSH));	--ep;
				      return (found(want,LT));
	case '>' :  if (*ep++ == '=') return (found(want,GE));	--ep;
		    if (*ep++ == '>') return (found(want,RSH));	--ep;
				      return (found(want,GT));
	case '=' :  if (*ep++ == '=') return (found(want,EQ));	--ep;
      }
    --ep;


    ep = getsy(ep,YES);				  /* Objekt Symbol	  */
    if (stsym[0]) return (found(want,SYM));	  /* und gueltig ?	  */
    if ((len = getnum(ep)) != 0)		  /* Objekt Zahl ?	  */
      {
	ep += len;
	return (found(want,NUM));
      }
    if (atend(*ep)) return (found(want,EOE));	  /* Ausdrucksende ?	  */
    return (NO);
  }





/**************************************************************************\
*									   *
* action      :	 Gefundenes Token mit gewuenschtem Token vergleichen,	   *
*		 bei Uebereinstimmung und nicht	Ausdrucksendetoken	   *
*		 Tokenspeicher ct loeschen.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 want	-  Token, was gewuenscht wird			   *
*		 have	-  Token, was gefunden wurde			   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 ct	-  Eingang: 0 oder aktuelles Token		   *
*			   Ausgang: neues (wenn	bei Eingang 0) oder altes  *
*				    Token wenn keine Uebereinstimmung mit  *
*				    want oder EOE, bei Uebereinstimmung	   *
*				    mit	want 0				   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 YES:  want == have					   *
*		 NO :  wan != have					   *
*									   *
\**************************************************************************/

BOOLEAN	found(want,have)

int want;
int have;

  {
    ct = have;				     /*	neues aktuelles	Token	  */
    if (ct == want)			     /*	wurde danach gesucht ?	  */
      {					     /*	ja, Tokenspeicher	  */
	if (ct != EOE) ct = 0;		     /*	loeschen wenn nicht EOE	  */
	return (YES);
      }
    return (NO);			     /*	nein			  */
  }





/**************************************************************************\
*									   *
* action      :	 Symbol	an *at nach stsym holen	und klassifizieren.	   *
*									   *
*		 Es werden hoechstens MAXLAB Zeichen nach stsym		   *
*		 uebertragen, geholt werden aber alle Zeichen des Symbols. *
*									   *
*		 Nach Holen des	Symbols	wird auf das naechste Zeichen	   *
*		 ungleich SPACE, TAB, CR, LF, FF positioniert und diese	   *
*		 Position zurueckgegeben.				   *
*									   *
*		 Alle nach stsym uebertragenen Buchstaben werden in	   *
*		 Grossbuchstaben umgewandelt.				   *
*									   *
*		 Ein Symbol darf nicht mit einer Zahl anfangen und sowohl  *
*		 Buchstaben als	auch Zahlen sowie _ $ ?	@ enthalten.	   *
*									   *
*		 SSSSSS:   -   Label					   *
*		 SSSSSS::  -   globales	Label (Entrypoint)		   *
*		 SSSSSS	   -   Name					   *
*		 SSSSSS##  -   Name, externe Referenz			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 at	  -  Zeiger auf	den zu untersuchenden String	   *
*		 ref	  -  YES: zu holendes Symbol muss Referenz sein,   *
*				  d.h. keine neue Definition sondern	   *
*				  Symbol oder Label innerhalb eines	   *
*				  Ausdrucks, badsym = NO, Abbruch beim	   *
*				  jedem	Nicht-Symbol-Zeichen, angehaengtes *
*				  ## bei einer externen	Referenz wird	   *
*				  beachtet (gotxr)			   *
*			     NO	: gotxr	= NO, ## wird nicht erkannt, bei   *
*				  Fehlern im Symbol wird badsym	= YES,	   *
*				  aber das Symbol wird trotzdem	bis zum	   *
*				  Ende abgearbeitet			   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 stsym	  -  Symbolstring, enthaelt nach Feststellen eines *
*			     Symbols bei at dieses Symbol nullterminiert   *
*		 gotlabel -  YES: Symbol ist Label (kein Name),	NO sonst   *
*		 gotnam	  -  YES: Symbol ist Name (kein	Label),	NO sonst   *
*		 badsym	  -  YES: nicht	erlaubte Zeichen im Symbol	   *
*		 gotep	  -  YES: Label	ist global (Entrypoint)		   *
*		 gotxr	  -  YES: Referenz (Symbol) ist	extern		   *
*									   *
* locals      :	 j	  -  Index in stsym				   *
*		 c	  -  geholtes Zeichen, Uppercase		   *
*									   *
* returns     :	 Zeiger	in den String hinter gefundenes	Symbol		   *
*									   *
\**************************************************************************/

char *getsy(at,ref)

char *at;
int   ref;

  {
    int	 j;
    int	 c;

    j =	badsym = gotep = gotxr = gotlabel = 0;	/* stsym-Anfang, defaults */
    if (!isdigit(*at))				/* Symbolstart keine Zahl */
      {
	LOOP					/* alle	Symbolzeichen ... */
	  {
	    switch (c =	toupper(*at))		/* Zeichen holen, wandeln */
	      {
		case '#':			/* externe Referenz,	  */
		  if (ref)			/* nur gueltig wenn ref	  */
		    {				/* gesetzt		  */
		      gotxr = YES;		/* Flag: externe Referenz */
		      if (*++at	== '#')	++at;	/* 2. #	ueberspringen	  */
		      break;			/* Symbolende		  */
		    }

		default	:
		  if (!islabel(c))		/* ungueltiges Zeichen :  */
		    {
		      if (ref) break;		/* Sym.-Ende bei Referenz */
		      badsym = YES;		/* sonst Flag: S.-Fehler  */
		    }
		  if (j	< MAXLAB)		/* Zeichen uebertragen	  */
		    stsym[j++] = c;		/* bis max. Labellaenge	  */
		  ++at;
		  continue;			/* naechstes Zeichen	  */

		case ':':			/* Label gefunden	  */
		  gotlabel = YES;		/* Flag: Label		  */
		  if (*++at == ':')		/* globales Label :	  */
		    {
		      gotep = YES;		/* Flag: Entrypoint	  */
		      ++at;			/* : ueberspringen	  */
		    }				/* Symbolende		  */

		case ' '     :			/*   "			  */
		case '\t'    :			/*   "			  */
		case '\n'    :			/*   "			  */
		case ','     :			/*   "			  */
		case NULL    :			/*   "			  */
		case COMMENT :	;		/* Symbolende		  */
	      }
	    while (isspace(*at)) ++at;		/* Symbolende, weiter	  */
	    break;				/* positionieren	  */
	  } /* end LOOP	*/
      }	/* end if (!isdigit(*at)) */
    stsym[j] = '\0';				/* Stringende S.-Speicher */
    if (stsym[0] && !gotlabel)			/* war nichtleerer Name	? */
      gotnam = YES;				/* ja, Flag: Name	  */
    else
      gotnam = NO;				/* nein, Flag: kein Name  */
    return (at);				/* naechste Pos. zurueck  */
  }



/* Ende	von MAC5.C */
