/**************************************************************************\
*									   *
*   MACV.C   -	 unido X-Mac, globale Variable				   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include "all.h"			/* allgemeine Festlegungen	  */
#include "mac.h"			/* Festlegungen	fuer MAC	  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"




/*								Globals	  */
/**************************************************************************/

char	    srcfn[FNSIZE+1];  /* Name der Quelldatei			  */
char	    objfn[FNSIZE+1];  /* Name der Objektdatei			  */
FILE	   *srcfile;	      /* Quelldatei				  */

			      /* Symboltabelle :			  */
int	    stn;	      /*   Anzahl der geladenen	Symbole		  */
char  **stp;		 /*   Zeiger auf Zeigertabelle in ST	     */
char  *st;		 /*   Zeiger auf Anfang	der ST		     */
char  *stend;		 /*   Zeiger hinter Ende der ST		     */
char  *stptr;		 /*   Zeiger auf Eintrag in ST		     */

char	    stsym[MAXLAB+1];  /* Temporaerspeicher fuer	Symbole,	  */
			      /* 0-terminierter	String			  */

			      /* Definitionstabelle fuer Makros	:	  */
char  *mt;		 /*   Zeiger auf Anfang	der MT		     */
char  *mtprev;		 /*   Zeiger auf letzten Eintrag in MT	     */
char  *mtnext;		 /*   Zeiger auf naechstes freie Byte in MT  */
char  *mtrept;		 /*   mtnext-Sicherung bei REPT		     */
char  *mtend;		 /*   Zeiger auf Ende der MT		     */
char  *mtptr;		 /*   Zeiger auf Eintrag in MT		     */
int	    mlnext;	      /*   Nummer naechstes Label in Makro	  */
int	    mlnbr[10];	      /*   Nummer des Makrolabels		  */
char  *mpptr[10];	 /*   Pointer fuer Makro-Parameter	     */

			      /* Flags :				  */
BOOLEAN	    badsym;	      /*   TRUE	= unzulaessiges	Symbol		  */
BOOLEAN	    gotep;	      /*   TRUE	= Einsprungpunkt gefunden	  */
BOOLEAN	    gotxr;	      /*   TRUE	= externe Referenz gefunden	  */
BOOLEAN	    gotlabel;	      /*   TRUE	= Label	gefunden		  */
BOOLEAN	    gotnam;	      /*   TRUE	= Name gefunden			  */
BOOLEAN	    eom;	      /*   TRUE	= Modulende			  */
BOOLEAN	    err;	      /*   TRUE	= Fehler			  */
BOOLEAN	    list = FALSE;     /*   TRUE	= Listing erzeugen		  */
BOOLEAN	    part1;	      /*   TRUE	= 1. Teil Listingzeile gedruckt	  */
BOOLEAN	    defmode;	      /*   TRUE	= Definitionsmodus Makro	  */
BOOLEAN	    expmode;	      /*   TRUE	= Expansionsmodus Makro		  */
BOOLEAN	    reptmode;	      /*   TRUE	= innerhalb REPT-Abarbeitung	  */

int	    pass = 1;	      /* aktueller Durchgang des Assemblers (1,2) */
unsigned    endv;	      /* END-Wert				  */
unsigned    endt;	      /* END-Typ				  */
int	    lerr;	      /* Flag fuer Zeilenfehler			  */
unsigned    loc;	      /* Positionszaehler			  */
unsigned    iloc;	      /* spezieller Positionszaehler fuer $	  */
unsigned    cloc;	      /* Sicherung loc bei CSEG	-> DSEG		  */
unsigned    dloc;	      /* Sicherung loc bei DSEG	-> CSEG		  */
unsigned    seg;	      /* aktuelles Segment PREL/DREL		  */
int	    lin;	      /* Zeilenzaehler				  */
int	    lline;	      /* Zeilennummer im Listing		  */
int	    ccnt;	      /* Zaehler der ausgegebenen Code-Zeichen	  */
int	    lpage;	      /* Seitenzaehler Listing			  */
int	    looks;	      /* Anzahl	Versuche, um Instrukt. zu finden  */
int	    reptno;	      /* Anzahl	Wiederholungen bei REPT		  */

char  *ep;		 /* Zeiger in zusammengesetzten	Ausdruck     */
char  *lp;		 /* Zeiger in Zeile			     */
char	    line[MAXLINE];    /* Quellzeile				  */
unsigned    prior;	      /* vorhergehende Referenz	in Kette	  */
unsigned    priort;	      /*   "		 "	"    "	 , Typ	  */

int	    number;	      /* Wert einer Zahl im Ausdruck		  */
int	    ct;		      /* aktuelles Token im Ausdruck		  */

int l1ops[] = {	OR,		0 }; /*	Operatoren in der Reihenfolge  */
int l2ops[] = {	XOR,		0 }; /*	ihres Vorrangs		       */
int l3ops[] = {	AND,		0 };
int l4ops[] = {	EQ,NE,		0 };
int l5ops[] = {	LE,GE,LT,GT,	0 };
int l6ops[] = {	LSH,RSH	,	0 };
int l7ops[] = {	PLUS,MINUS,	0 };
int l8ops[] = {	MULT,DIV,MOD,	0 };



/* Ende	von MACV.C */
