/*
**	File: LCHAR.C
**
**	QCX Library
**
**	D.3  -- (Stuff normally in ctype.h as macros)
**		D.3.1  Character testing (is---)
**		D.3.2  character case mapping (toupper, tolower)
**
**	NOTE: These routines assume that the ASCII character set is being used.
**
**	Copyright (c) 1984, 1985 Quality Computer Systems
**	All rights reserved.
**
**	Published by:	The Code Works
**			Box 62136
**			Santa Barbara, CA 93160
**
**	Modified: 4Apr85 rj
**		  9sep85 jc
*/

#include "stdio.h"

#define	TRUE	1
#define	FALSE	0

/*: toupper -- convert a lower case letter to upper case */
toupper(c)
register c;
	{
	return ((c>='a' && c<='z') ? c - ('a' - 'A') : c);
	}

/*: tolower -- convert an upper case letter to lower case */
tolower(c)
register c;
	{
	return ((c>='A' && c<='Z') ? c - ('A' - 'a') : c);
	}

/*: ispunct -- Is c a punctation character? */
ispunct(c)
	{
	return (isgraph(c) && !isalnum(c));
	}

/*: iscntrl -- Is c an ASCII control character? */
iscntrl(c)
register c;
	{
	return ((c >= 0 && c <= 31) || c == 127);
	}

/*: isalnum -- Is c a letter or a number */
isalnum(c)
register c;
	{
	return ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')
		|| (c >= '0' && c <= '9'));
	}

/*: isalpha -- Is c a letter */
isalpha(c)
register c;
	{
	return ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z'));
	}

/*: isupper -- Is c an upper case letter */
isupper(c)
	{
	return (c >= 'A' && c <= 'Z');
	}

/*: islower -- Is c a lower case letter */
islower(c)
	{
	return (c >= 'a' && c <= 'z');
	}

/*: isprint -- Is c a printable character? */
isprint(c)
	{
	return (c >= ' ' && c <= '~');
	}

/*: isgraph -- Is c a printable character other than space? */
isgraph(c)
	{
	return (c > ' ' && c <= '~');
	}

#ifndef _lint
/*: isdigit -- Is c a decimal digit */
isdigit() {
#asm
;isdigit(c)
	LD	HL,2
	ADD	HL,SP
	LD	A,(HL)
	CP	48
	JR	C,?ISDG1
	CP	58
	RET	C
?ISDG1: XOR	A
	LD	H,A
	LD	L,A
#endasm
	}

/*: isspace -- Is c white space */
isspace() {
#asm
;isspace(c)
	LD	HL,2
	ADD	HL,SP
	LD	A,(HL)
	CP	9
	JR	Z,?ISSP1
	CP	10
	JR	Z,?ISSP1
	CP	32
	JR	Z,?ISSP1
	CP	12
	JR	Z,?ISSP1
	CP	13
	JR	Z,?ISSP1
	XOR	A
	LD	H,A
	LD	L,A
	RET
?ISSP1: OR	H
#endasm
	}

/*: isxdigit -- Is c a hexadecimal digit? */
isxdigit() {
#asm
;isxdigit(c)
	LD	HL,2
	ADD	HL,SP
	LD	A,(HL)
	CP	48
	JR	C,?ISXDG1
	CP	58
	RET	C
	CP	65
	JR	C,?ISXDG1
	CP	71
	RET	C
	CP	97
	JR	C,?ISXDG1
	CP	103
	RET	C
?ISXDG1: XOR	A
	LD	H,A
	LD	L,A
#endasm
	}
#endif

/* end LCHAR.C */
